package com.ym.mec.biz.dal.entity;

import com.ym.mec.biz.dal.enums.PeriodEnum;
import com.ym.mec.common.entity.BaseEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;

import java.math.BigDecimal;
import java.util.List;

/**
 * 对应数据库表(cloud_coach_payment_program):
 */
public class CloudCoachPaymentProgram extends BaseEntity {

	/**  */
	private Long id;
	
	/** 会员名称 */
	private String name;
	
	/** 备注 */
	private String remark;
	
	/** 会员数量 */
	private BigDecimal memberNum = BigDecimal.ZERO;

	/** 云教练描述 */
	private String memberIntro;
	
	/** 缴费项目总人数 */
	private Integer userNum = 0;
	
	/** 已缴费人数 */
	private Integer paymentUserNum = 0;
	
	/** 单位（年月日） */
	private PeriodEnum period = PeriodEnum.MONTH;
	
	/** 会员等级编号 */
	private Integer memberRankSettingId = 1;
	
	/** 现价 */
	private java.math.BigDecimal actualAmount = BigDecimal.ZERO;
	
	/** 原价 */
	private java.math.BigDecimal originalAmount = BigDecimal.ZERO;
	
	/** 创建人 */
	private Integer operator;

	private String operatorName;
	
	/**  */
	private java.util.Date createTime;
	
	/**  */
	private java.util.Date updateTime;
	
	/**  */
	private Integer tenantId;

	private Integer organId;

	private List<Integer> userIds;

	public String getMemberIntro() {
		return memberIntro;
	}

	public void setMemberIntro(String memberIntro) {
		this.memberIntro = memberIntro;
	}

	public String getOperatorName() {
		return operatorName;
	}

	public void setOperatorName(String operatorName) {
		this.operatorName = operatorName;
	}

	public Integer getOrganId() {
		return organId;
	}

	public void setOrganId(Integer organId) {
		this.organId = organId;
	}

	public List<Integer> getUserIds() {
		return userIds;
	}

	public void setUserIds(List<Integer> userIds) {
		this.userIds = userIds;
	}

	public void setId(Long id){
		this.id = id;
	}
	
	public Long getId(){
		return this.id;
	}
			
	public void setName(String name){
		this.name = name;
	}
	
	public String getName(){
		return this.name;
	}
			
	public void setRemark(String remark){
		this.remark = remark;
	}
	
	public String getRemark(){
		return this.remark;
	}

	public BigDecimal getMemberNum() {
		return memberNum;
	}

	public void setMemberNum(BigDecimal memberNum) {
		this.memberNum = memberNum;
	}

	public PeriodEnum getPeriod() {
		return period;
	}

	public void setPeriod(PeriodEnum period) {
		this.period = period;
	}

	public void setUserNum(Integer userNum){
		this.userNum = userNum;
	}
	
	public Integer getUserNum(){
		return this.userNum;
	}
			
	public void setPaymentUserNum(Integer paymentUserNum){
		this.paymentUserNum = paymentUserNum;
	}
	
	public Integer getPaymentUserNum(){
		return this.paymentUserNum;
	}

	public void setMemberRankSettingId(Integer memberRankSettingId){
		this.memberRankSettingId = memberRankSettingId;
	}
	
	public Integer getMemberRankSettingId(){
		return this.memberRankSettingId;
	}
			
	public void setActualAmount(java.math.BigDecimal actualAmount){
		this.actualAmount = actualAmount;
	}
	
	public java.math.BigDecimal getActualAmount(){
		return this.actualAmount;
	}
			
	public void setOriginalAmount(java.math.BigDecimal originalAmount){
		this.originalAmount = originalAmount;
	}
	
	public java.math.BigDecimal getOriginalAmount(){
		return this.originalAmount;
	}
			
	public void setOperator(Integer operator){
		this.operator = operator;
	}
	
	public Integer getOperator(){
		return this.operator;
	}
			
	public void setCreateTime(java.util.Date createTime){
		this.createTime = createTime;
	}
	
	public java.util.Date getCreateTime(){
		return this.createTime;
	}
			
	public void setUpdateTime(java.util.Date updateTime){
		this.updateTime = updateTime;
	}
	
	public java.util.Date getUpdateTime(){
		return this.updateTime;
	}
			
	public void setTenantId(Integer tenantId){
		this.tenantId = tenantId;
	}
	
	public Integer getTenantId(){
		return this.tenantId;
	}
			
	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this);
	}

}
