package com.ym.mec.biz.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ym.mec.biz.dal.dto.ImLiveBroadcastRoomDto;
import com.ym.mec.biz.dal.entity.ImLiveBroadcastRoom;
import com.ym.mec.biz.dal.vo.ImLiveBroadcastRoomVo;
import com.ym.mec.common.page.PageInfo;

import java.util.Map;

/**
 * 直播房间管理表(ImLiveBroadcastRoom)表服务接口
 *
 * @author hgw
 * @since 2022-02-17 20:52:05
 */
public interface ImLiveBroadcastRoomService extends IService<ImLiveBroadcastRoom> {

    PageInfo<ImLiveBroadcastRoomVo> queryPage(Map<String, Object> param);

    ImLiveBroadcastRoomVo queryRoom(String roomUid, Integer userId);

    ImLiveBroadcastRoomVo queryRoomInfo(String roomUid);

    void add(ImLiveBroadcastRoomDto dto);

    void update(ImLiveBroadcastRoomDto dto);

    void roomDestroy(Integer id);

    void delete(Integer id);

    void syncLike(String roomUid, Integer likeNum);

    void joinRoom(String roomUid, Integer userId);

    void test();

    /**
    * @description: 分享直播链接
     * @param roomUid
    * @return void
    * @author zx
    * @date 2022/2/23 16:17
    */
    void shareGroup(String roomUid,String groupIds);
}

