package com.ym.mec.biz.service;

import com.ym.mec.biz.dal.dto.MemberPayParamDto;
import com.ym.mec.biz.dal.entity.MemberRankSetting;
import com.ym.mec.biz.dal.entity.StudentPaymentOrder;
import com.ym.mec.biz.dal.enums.PeriodEnum;
import com.ym.mec.common.entity.HttpResponseResult;
import com.ym.mec.common.service.BaseService;

import java.math.BigDecimal;
import java.util.List;

public interface MemberRankSettingService extends BaseService<Integer, MemberRankSetting> {

    void add(MemberRankSetting memberRankSetting);

    MemberRankSetting getDetail(Integer memberRankSettingId);

    void updateSetting(MemberRankSetting memberRankSetting);

    List<MemberRankSetting> queryListByIsDefault(Boolean isDefault);

    /**
     * 会员购买
     *
     * @return
     */
    HttpResponseResult buy(MemberPayParamDto memberPayParamDto) throws Exception;

    HttpResponseResult buy2Qqhe(MemberPayParamDto memberPayParamDto) throws Exception;

    HttpResponseResult queryBuy2Qqhe();

    HttpResponseResult closeBuy2Qqhe(String orderNo) throws Exception;

    /**
     * 订单回调
     *
     * @param studentPaymentOrder
     * @return
     */
    boolean orderCallback(StudentPaymentOrder studentPaymentOrder);

    HttpResponseResult ActiveBuy(Integer id, Integer memberRankId, PeriodEnum month, BigDecimal amount, boolean isUseBalance, Integer buyNum, int giveNum, int activeRemark, String remark, boolean repay) throws Exception;
}