package com.ym.mec.biz.service;

import com.alibaba.fastjson.JSONObject;
import com.ym.mec.biz.dal.dto.ExportDto;
import com.ym.mec.biz.dal.dto.ReplacementInstrumentActivityDto;
import com.ym.mec.biz.dal.entity.QuestionnaireQuestion;
import com.ym.mec.biz.dal.entity.QuestionnaireUserResult;
import com.ym.mec.biz.dal.enums.ExportEnum;
import com.ym.mec.biz.dal.enums.QuestionnaireActiveTypeEnum;
import com.ym.mec.biz.dal.page.QuestionnaireUserResultQueryInfo;
import com.ym.mec.common.exception.BizException;
import com.ym.mec.common.page.QueryInfo;
import com.ym.mec.common.service.BaseService;
import com.ym.mec.common.tenant.TenantContextHolder;
import com.ym.mec.util.date.DateUtil;
import com.ym.mec.util.excel.POIUtil;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.util.*;
import java.util.stream.Collectors;

import static com.ym.mec.biz.dal.enums.QuestionnaireActiveTypeEnum.CLOUD_TEACHER_FEEDBACK;

public interface QuestionnaireUserResultService extends BaseService<Long, QuestionnaireUserResult> {

    void batchInsert(List<QuestionnaireUserResult> questionnaireUserResultList);

    Object queryDetailPage(QueryInfo queryInfo);

    /**
     *
     * @param cooperationId
     * @param questionList
     * @return
     */
    Map<String,Object> questionnaireUserResultExport(String activeType,Integer cooperationId, List<QuestionnaireQuestion> questionList);

    /**
     * 提交调查问卷
     * @param replacementInstrumentActivityDto
     * @return
     */
    void add(ReplacementInstrumentActivityDto replacementInstrumentActivityDto);

    /**
    * @description: 提交调查问卷（没有活动）
     * @param replacementInstrumentActivity
    * @return void
    * @author zx
    * @date 2021/12/2 17:24
    */
    void addResult(ReplacementInstrumentActivityDto replacementInstrumentActivity);

    Object queryResultPage(QuestionnaireUserResultQueryInfo queryInfo);

    /**
    * @description: 获取问卷导出字段
     * @param
    * @return java.util.List<java.lang.String>
    * @author zx
    * @date 2022/2/14 11:18
    */
    List<String> getExportFields(Integer cooperationId, QuestionnaireActiveTypeEnum activeType,List<QuestionnaireQuestion> questionList);

    /**
    * @description: 获取问卷导出字段
     * @param
    * @return java.util.List<java.lang.String>
    * @author zx
    * @date 2022/2/14 11:18
    */
    Set<String> getExportBody(Integer cooperationId, QuestionnaireActiveTypeEnum activeType,List<QuestionnaireQuestion> questionList);

    List<QuestionnaireQuestion> getQuestionnaireQuestions(Integer cooperationId, QuestionnaireActiveTypeEnum activeType);

    //导出问卷调查
    void questionnaireUserResultExport(HttpServletResponse response, ExportDto exportDto) throws Exception;
}