package com.ym.mec.biz.service.impl;

import java.io.*;
import java.math.BigDecimal;
import java.util.*;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.function.BiFunction;
import java.util.function.Function;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ym.mec.auth.api.client.SysUserFeignService;
import com.ym.mec.auth.api.entity.SysUser;
import com.ym.mec.biz.dal.dao.*;
import com.ym.mec.biz.dal.dto.*;
import com.ym.mec.biz.dal.entity.*;
import com.ym.mec.biz.dal.enums.*;
import com.ym.mec.biz.dal.page.*;
import com.ym.mec.biz.service.*;
import com.ym.mec.common.constant.CommonConstants;
import com.ym.mec.common.controller.BaseController;
import com.ym.mec.common.entity.HttpResponseResult;
import com.ym.mec.common.exception.BizException;
import com.ym.mec.common.page.PageInfo;
import com.ym.mec.common.service.IdGeneratorService;
import com.ym.mec.thirdparty.adapay.ConfigInit;
import com.ym.mec.thirdparty.adapay.Payment;
import com.ym.mec.util.collection.MapUtil;
import com.ym.mec.util.ini.IniFileUtil;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.system.ApplicationHome;
import org.springframework.core.io.ClassPathResource;
import org.springframework.http.HttpStatus;
import org.springframework.scheduling.annotation.Async;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.stereotype.Service;

import com.ym.mec.common.tenant.TenantContextHolder;
import com.ym.mec.thirdparty.storage.StoragePluginContext;
import com.ym.mec.thirdparty.storage.provider.KS3StoragePlugin;
import com.ym.mec.util.date.DateUtil;
import com.ym.mec.util.excel.POIUtil;
import com.ym.mec.util.upload.UploadUtil;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.GetMapping;

import javax.annotation.PostConstruct;
import javax.servlet.http.HttpServletResponse;

import static com.ym.mec.biz.dal.enums.QuestionnaireActiveTypeEnum.CLOUD_TEACHER_FEEDBACK;

@Service
public class ExportServiceImpl implements ExportService {

    @Autowired
    private StudentPaymentOrderService studentPaymentOrderService;
    @Autowired
    private StudentPaymentRouteOrderDao studentPaymentRouteOrderDao;
    @Autowired
    private VipGroupDao vipGroupDao;
    @Autowired
    private PracticeGroupDao practiceGroupDao;
    @Autowired
    private SellOrderDao sellOrderDao;
    @Autowired
    private StudentRegistrationDao studentRegistrationDao;
    @Autowired
    private MusicGroupDao musicGroupDao;
    @Autowired
    private StoragePluginContext storagePluginContext;
    @Autowired
    private ManagerDownloadDao managerDownloadDao;
    @Autowired
    private CooperationOrganDao cooperationOrganDao;
    @Autowired
    private ReplacementInstrumentActivityDao replacementInstrumentActivityDao;
    @Autowired
    private CourseScheduleService courseScheduleService;
    @Autowired
    private StudentService studentService;
	@Autowired
	private TenantConfigService tenantConfigService;
    @Autowired
    private CourseScheduleStudentPaymentDao courseScheduleStudentPaymentDao;
    @Autowired
    private StudentRegistrationService studentRegistrationService;
    @Autowired
    private StudentManageService studentManageService;
    @Autowired
    private StudentPaymentOrderDetailService studentPaymentOrderDetailService;
    @Autowired
    private CourseScheduleTeacherSalaryService courseScheduleTeacherSalaryService;
    @Autowired
    private SysUserFeignService sysUserFeignService;
    @Autowired
    private OrganizationService organizationService;
    @Autowired
    private StudentInstrumentDao studentInstrumentDao;
    @Autowired
    private VipGroupService vipGroupService;
    @Autowired
    private PracticeGroupService practiceGroupService;
    @Autowired
    private CourseScheduleService scheduleService;
    @Autowired
    private SporadicChargeInfoService sporadicChargeInfoService;
    @Autowired
    private CourseReviewService courseReviewService;
    @Autowired
    private TenantPaymentOrderService tenantPaymentOrderService;
    @Autowired
    private CourseScheduleDao courseScheduleDao;
    @Autowired
    private ExtracurricularExercisesReplyService extracurricularExercisesReplyService;
    @Autowired
    private StudentExtracurricularExercisesSituationService studentExtracurricularExercisesSituationService;
    @Autowired
    private TeacherSalaryComplaintsService teacherSalaryComplaintsService;
    @Autowired
    private TeacherAttendanceService teacherAttendanceService;
    @Autowired
    private StudentAttendanceService studentAttendanceService;
    @Autowired
    private TeacherCourseRewardService teacherCourseRewardService;
    @Autowired
    private DegreeRegistrationService degreeRegistrationService;
    @Autowired
    private CooperationOrganService cooperationOrganService;
    @Autowired
    private StudentPaymentOrderDao studentPaymentOrderDao;
    @Autowired
    private StudentDao studentDao;
    @Autowired
    private MusicGroupPaymentCalenderDetailService musicGroupPaymentCalenderDetailService;
    @Autowired
    private TeacherService teacherService;
    @Autowired
    private MusicGroupBuildLogDao musicGroupBuildLogDao;
    @Autowired
    private MusicGroupPaymentCalenderService musicGroupPaymentCalenderService;
    @Autowired
    private SellOrderService sellOrderService;
    @Autowired
    private VipGroupActivityService vipGroupActivityService;
    @Autowired
    private GoodsService goodsService;
    @Autowired
    private ClassGroupService classGroupService;
    @Autowired
    private IdGeneratorService idGeneratorService;
    @Autowired
    private MusicGroupQuitService musicGroupQuitService;
    @Autowired
    private IndexBaseMonthDataService indexService;
    @Autowired
    private TeacherCourseStatisticsService teacherCourseStatisticsService;
    @Autowired
    private SysUserCashAccountDetailDao sysUserCashAccountDetailDao;
    @Autowired
    private SysUserCoursesAccountDetailDao sysUserCoursesAccountDetailDao;
    @Autowired
    private ChildrenDayReserveService childrenDayReserveService;
    @Autowired
    private IndexErrDataRecordService indexErrDataRecordService;
    @Autowired
    private EmployeeInfoService employeeInfoService;
    @Autowired
    private MusicEnlightenmentQuestionnaireService musicEnlightenmentQuestionnaireService;
    @Autowired
    private MusicGroupService musicGroupService;
    @Autowired
    private SysUserCashAccountLogService sysUserCashAccountLogService;

    @Value("${spring.profiles.active:dev}")
    private String profiles;


    @Override
    public Map<String,String> getExportMap(ExportDto exportDto) throws IOException {
        List<String> paramColumns = exportDto.getHeadColumns();
        if(paramColumns == null || paramColumns.size() == 0){
            throw new BizException("请选择导出字段");
        }
        if(exportDto.getExportEnum() == null){
            throw new BizException("请选择导出类型");
        }
        Map<String, String> columns = loadColumnMapper(exportDto.getExportEnum());
        List<String> headColumns = JSONObject.parseObject(columns.get("headColumns"), List.class);
        List<String> fieldColumns = JSONObject.parseObject(columns.get("fieldColumns"), List.class);
        Map<String,String> headMap = new LinkedHashMap<>(headColumns.size());
        for (int i = 0; i < headColumns.size(); i++) {
            headMap.put(headColumns.get(i),fieldColumns.get(i));
        }
        headMap.keySet().removeAll(org.apache.commons.collections.CollectionUtils.subtract(headColumns, paramColumns));
        return headMap;
    }

    @Override
    public List<String> getExportFields(ExportEnum exportEnum) throws IOException {
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        if(sysUser == null || sysUser.getId() == null){
            throw new BizException("请登录");
        }
        if(exportEnum == ExportEnum.ORDER_LIST1 || exportEnum == ExportEnum.ORDER_LIST2){
            if(sysUser.getTenantId() <= 0){
                exportEnum = ExportEnum.ORDER_LIST1;
            }else {
                exportEnum = ExportEnum.ORDER_LIST2;
            }
        }else if(exportEnum == ExportEnum.ROUTE_ORDER_LIST1 || exportEnum == ExportEnum.ROUTE_ORDER_LIST2){
            if(sysUser.getTenantId() <= 0){
                exportEnum = ExportEnum.ROUTE_ORDER_LIST1;
            }else {
                exportEnum = ExportEnum.ROUTE_ORDER_LIST2;
            }
        }
        return JSONObject.parseObject(loadColumnMapper(exportEnum).get("headColumns"), List.class);
    }

    private Map<String, String> loadColumnMapper(ExportEnum exportEnum) throws IOException {
        InputStream inputStream = new ClassPathResource("exportColumnMapper.ini").getInputStream();
        return IniFileUtil.readIniFile(inputStream, exportEnum.getMsg());
    }

    @Override
    public <T> void export(HttpServletResponse response, List<T> rows, ExportDto exportDto) throws IOException {
        if(rows == null || rows.size() == 0){
            throw new BizException("没有可导出数据");
        }
        //获取表头和字段
        Map<String,String> headMap = getExportMap(exportDto);
        OutputStream outputStream = response.getOutputStream();
        try {
            String[] head = headMap.keySet().toArray(new String[headMap.keySet().size()]);
            String[] field = headMap.values().toArray(new String[headMap.keySet().size()]);
            HSSFWorkbook workbook = POIUtil.exportExcel(head,field, rows);
            response.setContentType("application/octet-stream");
            response.setHeader("Content-Disposition", "attac:wq" +
                    "hment;filename=" + DateUtil.getDate(new Date()) + ".xls");
            outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (outputStream != null) {
                try {
                    outputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }
    //导出到报表中心
    private Map<ExportEnum, BiFunction<Map<String,Object>,List<String>, HttpResponseResult>> exportManageFuncMap = new HashMap<>(ExportEnum.values().length);
    //直接导出
    private Map<ExportEnum, Function<Map<String,Object>,List>> exportFuncMap = new HashMap<>(ExportEnum.values().length);

    @Override
    public Map<ExportEnum, BiFunction<Map<String, Object>,List<String>, HttpResponseResult>> getExportManageFuncMap() {
        return exportManageFuncMap;
    }

    @Override
    public Map<ExportEnum, Function<Map<String, Object>, List>> getExportFuncMap() {
        return exportFuncMap;
    }

    @PostConstruct
    public void exportFuncMapInit(){
        exportFuncMap.put(ExportEnum.USER_CASH_ACCOUNT_LOG, info -> sysUserCashAccountLogService.queryPage(getQueryInfo(info, AccountLogQueryInfo.class, true)).getRows());
        exportFuncMap.put(ExportEnum.MUSIC_GROUP, info -> musicGroupService.queryMusicGroupPage(getQueryInfo(info, MusicGroupQueryInfo.class, true)).getRows());
        exportFuncMap.put(ExportEnum.STATISTICS_DETAIL, info -> childrenDayReserveService.exportStatisticsDetail(getQueryInfo(info, ChildrenReserveQueryInfo.class, true)));
        exportFuncMap.put(ExportEnum.DOUBLE_ELEVEN2021_ORDER_DETAIL, info -> vipGroupActivityService.doubleEleven2021OrderDetail(getQueryInfo(info, DoubleEleven2021QueryInfo.class, false)).getRows());
        exportFuncMap.put(ExportEnum.ORGAN_DOUBLE_ELEVEN2021_STATIS, info -> vipGroupActivityService.organDoubleEleven2021Statis(getQueryInfo(info, OrganDoubleEleven2021StatisDto.class, false)));
        exportFuncMap.put(ExportEnum.USER_CASH_ACCOUNT_DETAIL, info -> sysUserCashAccountDetailDao.exportDetail(getQueryInfo(info, ExportUserAccountQueryInfo.class, true)));
        exportFuncMap.put(ExportEnum.USER_COURSES_ACCOUNT, info -> sysUserCoursesAccountDetailDao.exportDetail(getQueryInfo(info, ExportUserAccountQueryInfo.class, true)));
        exportFuncMap.put(ExportEnum.CLASS_GROUP, info -> exportClassGroup(info));
        exportFuncMap.put(ExportEnum.GOODS, info -> goodsService.queryPage(getQueryInfo(info,GoodsQueryInfo.class,false)).getRows());
        exportFuncMap.put(ExportEnum.VIP_GROUP_ACTIVITY, info -> vipGroupActivityService.exportVipGroupActivity(getQueryInfo(info,VipGroupActivityQueryInfo.class,true)));
        exportFuncMap.put(ExportEnum.EXPORT_STUDENT_ATTENDANCES, info -> studentAttendanceService.exportStudentAttendancesQueryPage(getQueryInfo(info, ExportStudentAttendanceQueryInfo.class, true)).getRows());
        exportFuncMap.put(ExportEnum.MUSIC_GROUP_PAYMENT_CALENDER_DETAIL, info -> musicGroupPaymentCalenderDetailService.queryDetailPage(getQueryInfo(info, MusicCalenderDetailQueryInfo.class, false)).getRows());
        exportFuncMap.put(ExportEnum.EXPORT_PAYMENT_CALENDER_AUDIT_LIST, info -> musicGroupPaymentCalenderService.auditList(getQueryInfo(info, MusicGroupPaymentCalenderQueryInfo.class, true)).getRows());
        exportFuncMap.put(ExportEnum.QUERY_TEACHER_ATTENDANCES, info -> teacherAttendanceService.queryTeacherAttendances(getQueryInfo(info,TeacherCloseQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.TEACHER_SALARY_COMPLAINTS, info -> teacherSalaryComplaintsService.queryPage(getQueryInfo(info,TeacherSalaryModifyQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.STUDENT_BUY_PRACTICE, info -> practiceGroupService.studentBuys(getQueryInfo(info,StudentBuyPracticeQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.TENANT_PAYMENT_ORDER, info -> tenantPaymentOrderService.queryPage(getQueryInfo(info,TenantPaymentOrderQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.TEACHER_SALARY, info -> courseScheduleTeacherSalaryService.exportTeacherSalary(getQueryInfo(info,ExportTeacherSalaryQueryInfo.class,false)));
        exportFuncMap.put(ExportEnum.TEACHER_COURSE_REWARD, info -> teacherCourseReward(info));
        exportFuncMap.put(ExportEnum.STUDENT_HAS_COURSE, info -> studentManageService.findStudentsByOrganId(getQueryInfo(info,StudentManageQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.PRACTICE_GROUP_LIST, info -> practiceGroupList(info));
        exportFuncMap.put(ExportEnum.VIP_GROUP_LIST, info -> vipGroupService.findVipGroups(getQueryInfo(info,VipGroupQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.SPORADIC_CHARGE_INFO, info -> sporadicChargeInfoService.queryDetailPage(getQueryInfo(info,SporadicChargeInfoQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.MUSICAL_LIST_EXPORT, info -> studentPaymentOrderDetailService.getMusicalList(getParam(info,"musicGroupId",String.class)));
        exportFuncMap.put(ExportEnum.MUSICAL_LIST_DETAIL_EXPORT, info -> studentPaymentOrderDetailService.getMusicalListDetail(getParam(info,"musicGroupId",String.class), null));
        exportFuncMap.put(ExportEnum.QUERY_STUDENT_APPLY_DETAIL_EXPORT, info -> queryStudentApplyDetailExport(info));
        exportFuncMap.put(ExportEnum.COURSE_SCHEDULE_TEACHER_SALARY, info -> courseScheduleTeacherSalaryService.querySalaries(getQueryInfo(info,CourseScheduleTeacherSalaryQueryInfo.class,false)).getRows());
        exportFuncMap.put(ExportEnum.MUSIC_GROUP_STUDENT, info -> queryMusicGroupStudent(info));
        exportFuncMap.put(ExportEnum.COURSE_REVIEWS, info -> courseReviews(info));
        exportFuncMap.put(ExportEnum.PRACTICE_GROUP, info -> practiceGroup());
        exportFuncMap.put(ExportEnum.VIP_GROUP, info -> vipGroup());
        exportFuncMap.put(ExportEnum.EXTRA_EXERCISES_REPLYS, info -> extraExercisesReplys(info));
        exportFuncMap.put(ExportEnum.EXERCISES_SITUATIONS, info -> studentExtracurricularExercisesSituationService.findStudentExtracurricularExercisesSituations(getQueryInfo(info,StudentExercisesSituationQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.IS_SETTLEMENT_COURSE_SALARYS, info -> isSettlementCourseSalarys(info));
        exportFuncMap.put(ExportEnum.OPERATING_STUDENTS, info -> operatingStudents(info));
        exportFuncMap.put(ExportEnum.VIP_COURSE_REVIEWS, info -> vipCourseReviews(info));
        exportFuncMap.put(ExportEnum.DEGREE_REGISTRATION, info -> degreeRegistration(info));
        exportFuncMap.put(ExportEnum.COOPERATION_ORGAN, info -> cooperationOrganService.queryPage(getQueryInfo(info,CooperationOrganQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.TEACHER_DEFAULT_SALARY, info -> teacherService.queryTeacherDefaultSalary(getParam(info,"organIdList",String.class)));
        exportFuncMap.put(ExportEnum.STUDENT_ORDER, info -> studentOrder(info));
        exportFuncMap.put(ExportEnum.EXPORT_SELL_ORDERS, info -> exportSellOrders(info));
        exportFuncMap.put(ExportEnum.ARREARAGE_STUDENTS, info -> musicGroupPaymentCalenderDetailService.queryArrearageStudents(getQueryInfo(info,ArrearageStudentsQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.MUSIC_GROUP_QUIT, info -> musicGroupQuitService.queryPage(getQueryInfo(info,MusicGroupQuitQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.TEACHER_SERVE_INFO, info -> teacherServeInfo(info));
        exportFuncMap.put(ExportEnum.EXPORT_INDEX_ERR_DATA, info -> exportIndexErrData(info));
        exportFuncMap.put(ExportEnum.TEACHER_COURSE_STATISTICS, info -> teacherCourseStatisticsService.queryPageDetail(getQueryInfo(info,TeacherCourseStatisticsQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.EXPORT_INDEX_HISTORY_ERR_DATA, info -> indexErrDataRecordService.queryRecord(getQueryInfo(info,IndexErrRecordQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.TEACHER_LIST, info -> teacherService.queryPageDetail(getQueryInfo(info,TeacherQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.EMPLOYEE_INFO, info -> employeeInfoService.queryPage(getQueryInfo(info,EmployeeInfoQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.ORGAN_TEACHER_MEMBER_STUDENT_DATA, info -> teacherService.queryMemberStudentData(getQueryInfo(info,TeacherServeQueryInfo.class,true)).getRows());
        exportFuncMap.put(ExportEnum.ORGAN_STUDENT_OVER_VIEW, info -> organStudentOverView(info));
        exportFuncMap.put(ExportEnum.CLOUD_STUDY_STUDENT_OVER_VIEW, info -> cloudStudyStudentOverView(info));
        exportFuncMap.put(ExportEnum.CLOUD_STUDY_STUDENT_TRAIN_DATA, info -> cloudStudyStudentTrainData(info));
        exportFuncMap.put(ExportEnum.COUNT_CLOUD_TEACHER_ACTIVE, info -> countCloudTeacherActive(info));
        exportFuncMap.put(ExportEnum.COUNT_CLOUD_TEACHER_ACTIVE_DETAIL, info -> countCloudTeacherActiveDetail(info));
        exportFuncMap.put(ExportEnum.MUSIC_ENLIGHTENMENT_QUESTIONNAIRES, info -> musicEnlightenmentQuestionnaireService.queryPage(getQueryInfo(info,TeacherServeQueryInfo.class,false)).getRows());
        exportFuncMap.put(ExportEnum.EXERCISES_SITUATION, info -> studentExtracurricularExercisesSituationService.queryTeacherPerformanceIndicator(getQueryInfo(info,TeacherServeQueryInfo.class,false)));
        exportFuncMap.put(ExportEnum.STUDENT_INSTRUMENT, info -> exportStudentInstrument(info));
        exportFuncMap.put(ExportEnum.EXPORT_BILL, info -> exportBill(info));

        //导出到报表中心
//        exportManageFuncMap.put(ExportEnum.SUPER_FIND_COURSE_SCHEDULES, (info,headColumns) -> this.superFindCourseSchedules(info,headColumns));
        //针对不同的用户有不同的模板
        exportManageFuncMap.put(ExportEnum.ROUTE_ORDER_LIST1, (info,headColumns) -> routeOrderList(info,headColumns));
        exportManageFuncMap.put(ExportEnum.ROUTE_ORDER_LIST2, (info,headColumns) -> routeOrderList(info,headColumns));
        exportManageFuncMap.put(ExportEnum.ORDER_LIST1, (info,headColumns) -> orderList(info,headColumns));
        exportManageFuncMap.put(ExportEnum.ORDER_LIST2, (info,headColumns) -> orderList(info,headColumns));
        exportManageFuncMap.put(ExportEnum.STUDENT_VIP_PRACTICE, (info,headColumns) -> exportStudentVipPractice(info,headColumns));

    }

    //导出对账单
    @Override
    public List exportBill(Map<String, Object> info){
        String startTimeStr = getParam(info, "startTime", String.class);
        Date startTime = null;
        if(StringUtils.isNotEmpty(startTimeStr)){
            startTime = DateUtil.stringToDate(startTimeStr,DateUtil.ISO_EXPANDED_DATE_FORMAT);
        }
        Date endTime = null;
        String endTimeStr = getParam(info, "endTime", String.class);
        if(StringUtils.isNotEmpty(endTimeStr)){
            endTime = DateUtil.stringToDate(endTimeStr,DateUtil.ISO_EXPANDED_DATE_FORMAT);
        }
        long createdGte = startTime.getTime();
        long createdLte = DateUtil.getLastSecondWithDay(endTime).getTime();
        int pageIndex = 1;
        List<Map<String, Object>> data = new ArrayList<>();
        while (profiles.equals("prod")) {
            Map<String, Object> paymentList = null;
            try {
                paymentList = Payment.queryList(pageIndex, createdGte, createdLte);
            } catch (Exception e) {
                e.printStackTrace();
            }
            JSONArray payments = (JSONArray) paymentList.get("payments");
            if (!paymentList.get("status").equals("succeeded")) {
                throw new BizException("查询失败，请重试");
            }

            if (payments != null && payments.size() > 0) {
                for (Object payment : payments) {
                    Map<String, Object> paymentMap = (Map<String, Object>) payment;
                    if (!paymentMap.get("status").equals("succeeded")) {
                        continue;
                    }
                    paymentMap.put("created_time", DateUtil.timeStamp2Date(paymentMap.get("created_time").toString(), null));
                    if (paymentMap.get("pay_channel").equals("alipay_qr")) {
                        paymentMap.put("pay_channel", "支付宝正扫");
                    } else if (paymentMap.get("pay_channel").equals("alipay_wap")) {
                        paymentMap.put("pay_channel", "支付宝H5支付");
                    } else {
                        paymentMap.put("pay_channel", "微信公众号支付");
                    }

                    if (paymentMap.get("status").equals("pending")) {
                        paymentMap.put("status", "交易处理中");
                    } else if (paymentMap.get("status").equals("succeeded")) {
                        paymentMap.put("status", "交易成功");
                    } else {
                        paymentMap.put("status", "交易失败");
                    }
                    if (paymentMap.get("pay_mode").equals("delay")) {
                        if (!paymentMap.containsKey("payment_confirms")) {
                            Map<String, Object> confirmMap = null;
                            try {
                                confirmMap = Payment.queryConfirmList(paymentMap.get("id").toString());
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                            if (confirmMap.containsKey("payment_confirms")) {
                                paymentMap.put("payment_confirms", confirmMap.get("payment_confirms"));
                            }
                        }
                        if (!paymentMap.containsKey("payment_confirms")) {
                            paymentMap.put("memo", "没有提交分账信息，请联系技术核查");
                            data.add(paymentMap);
                            continue;
                        }
                        JSONArray confirms = (JSONArray) paymentMap.get("payment_confirms");
                        for (Object confirm : confirms) {
                            Map<String, Object> divMemberMap = (Map<String, Object>) confirm;
                            paymentMap.put("fee_amt", divMemberMap.get("fee_amt"));
                            divMemberMap.putAll(paymentMap);

                            JSONArray divMembers = (JSONArray) divMemberMap.get("div_members");
                            Map<String, Object> divMember = (Map<String, Object>) divMembers.get(0);
                            divMemberMap.putAll(divMember);
                            if (divMemberMap.get("member_id").equals("0")) {
                                divMemberMap.put("member_id", ConfigInit.merNo);
                            }
                            data.add(divMemberMap);
                        }
                    } else {
                        JSONArray divMembers = (JSONArray) paymentMap.get("div_members");
                        for (Object divMember : divMembers) {
                            Map<String, Object> divMemberMap = (Map<String, Object>) divMember;
                            divMemberMap.putAll(paymentMap);
                            if (divMemberMap.get("member_id").equals("0")) {
                                divMemberMap.put("member_id", ConfigInit.merNo);
                            }
                            if (divMemberMap.get("fee_flag").equals("N")) {
                                divMemberMap.put("fee_amt", "0.00");
                            }
                            data.add(divMemberMap);
                        }
                    }
                }
            }
            if (paymentList.get("has_more").equals(false)) {
                break;
            }
            pageIndex++;
        }
        return data;
    }

    //乐保导出
    @Override
    public List exportStudentInstrument(Map<String, Object> info){
        String startTimeStr = getParam(info, "startTime", String.class);
        Date startTime = null;
        if(StringUtils.isNotEmpty(startTimeStr)){
            startTime = DateUtil.stringToDate(startTimeStr,DateUtil.ISO_EXPANDED_DATE_FORMAT);
        }
        Date endTime = null;
        String endTimeStr = getParam(info, "endTime", String.class);
        if(StringUtils.isNotEmpty(endTimeStr)){
            endTime = DateUtil.stringToDate(endTimeStr,DateUtil.ISO_EXPANDED_DATE_FORMAT);
        }
        String organId = organizationService.getEmployeeOrgan("");

        if (startTime != null) {
            startTime = DateUtil.trunc(startTime);
        }
        if (endTime != null) {
            endTime = DateUtil.getLastTimeWithDay(endTime);
        }
        List<StudentInstrumentExportDto> instruments = studentInstrumentDao.getInstruments(startTime, endTime, organId, TenantContextHolder.getTenantId());

        if (instruments.size() <= 0) {
            throw new BizException("没有可导出的记录");
        }
        for (StudentInstrumentExportDto instrument : instruments) {
            StudentRegistration studentMusicGroup = studentInstrumentDao.findStudentMusicGroup(instrument.getStudentId());
            if (studentMusicGroup != null) {
                instrument.setRepairerName(studentMusicGroup.getParentsName());
                instrument.setMusicGroupName(studentMusicGroup.getClassGroupName());
                instrument.setStudentStatus(studentMusicGroup.getMusicGroupStatus());
            }
        }
        return instruments;
    }

    //班级列表导出
    @Override
    public List exportClassGroup(Map<String, Object> info){
        ClassGroupQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),ClassGroupQueryInfo.class);
        queryInfo.setOrganId(organizationService.getEmployeeOrgan(queryInfo.getOrganId()));
        List<ClassGroupTeachersDto> rows = classGroupService.queryClassGroupPage(queryInfo).getRows();
        for (ClassGroupTeachersDto row : rows) {
            List<ClassGroupTeacherMapper> classGroupTeacherMapperList = row.getClassGroupTeacherMapperList();
            if (classGroupTeacherMapperList.size() > 0) {
                List<ClassGroupTeacherMapper> teachingTeachers = classGroupTeacherMapperList.stream().filter(e -> e.getTeacherRole() == TeachTypeEnum.TEACHING).collect(Collectors.toList());
                if (teachingTeachers.size() > 0) {
                    row.setTeachingTeacherName(StringUtils.join(teachingTeachers.stream().map(e -> e.getUserName()).collect(Collectors.toList()), ","));
                }
                List<ClassGroupTeacherMapper> bishopTeachers = classGroupTeacherMapperList.stream().filter(e -> e.getTeacherRole() == TeachTypeEnum.BISHOP).collect(Collectors.toList());
                if (bishopTeachers.size() > 0) {
                    row.setBishopTeacherName(StringUtils.join(bishopTeachers.stream().map(e -> e.getUserName()).collect(Collectors.toList()), ","));
                }
            }
        }
        return rows;
    }

    //导出老师结转奖励
    @Override
    public List teacherCourseReward(Map<String, Object> info){
        TeacherCourseRewardQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),TeacherCourseRewardQueryInfo.class);
        Date endTime = queryInfo.getEndTime();
        if (endTime != null) {
            queryInfo.setEndTime(DateUtil.addDays(endTime, 1));
        }
        return teacherCourseRewardService.queryPage(queryInfo).getRows();
    }

    //导出陪练课列表
    @Override
    public List practiceGroupList(Map<String, Object> info){
        PracticeGroupQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),PracticeGroupQueryInfo.class);
        queryInfo.setOrganId(organizationService.getEmployeeOrgan(queryInfo.getOrganId()));
        List<PracticeGroupDto> rows = practiceGroupService.findPracticeGroups(queryInfo).getRows();
        if (rows != null && rows.size() > 0) {
            rows.forEach(e -> {
                e.setSubClassTimes(e.getTotalClassTimes() == null ? 0 : e.getTotalClassTimes() - (e.getCurrentClassTimes() == null ? 0 : e.getCurrentClassTimes()));
                if (e.getBuyMonths() == null || e.getBuyMonths() == 0) {
                    e.setPayStatus("免费");
                } else {
                    if (e.getBeRenewGroupId() == null || e.getBeRenewGroupId() == 0l) {
                        e.setPayStatus("首充");
                    } else {
                        e.setPayStatus("续费");
                    }
                }
            });
        }
        return rows;
    }

    //乐团【报名中、缴费中】 学生详情列表导出
    @Override
    public List queryStudentApplyDetailExport(Map<String, Object> info){
        StudentRegistrationQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),StudentRegistrationQueryInfo.class);
        List<StudentApplyDetailDto> studentApplyDetail = studentRegistrationService.queryStudentDetailPage(queryInfo).getRows();
        if (studentApplyDetail.size() <= 0) {
            throw new BizException("没有可导出的记录");
        }
        List<MusicalListDetailDto> musicalListDetails = studentPaymentOrderDetailService.getMusicalListDetail(queryInfo.getMusicGroupId(), null);
        //获取分部年级列表
        MusicGroup musicGroup = musicGroupDao.get(queryInfo.getMusicGroupId());
        Map<Integer, String> gradeList = organizationService.getGradeList(musicGroup.getOrganId());
        for (StudentApplyDetailDto studentApplyDetailDto : studentApplyDetail) {
            if(StringUtils.isNotEmpty(studentApplyDetailDto.getCurrentGrade())){
                String grade = gradeList.get(Integer.parseInt(studentApplyDetailDto.getCurrentGrade()));
                if(StringUtils.isNotEmpty(grade)){
                    studentApplyDetailDto.setCurrentGrade(grade);
                }
            }
            for (MusicalListDetailDto musicalListDetail : musicalListDetails) {
                if (!musicalListDetail.getUserId().equals(studentApplyDetailDto.getStudentId())) continue;
                studentApplyDetailDto.setKitGroupPurchaseTypeEnum(musicalListDetail.getKitGroupPurchaseTypeEnum());
            }
            if (PaymentStatusEnum.YES.equals(studentApplyDetailDto.getPaymentStatus()) && studentApplyDetailDto.getKitGroupPurchaseTypeEnum() == null) {
                studentApplyDetailDto.setKitGroupPurchaseTypeEnum(KitGroupPurchaseTypeEnum.OWNED);
            }
            if(studentApplyDetailDto.getPayingStatus().equals(1)){
                studentApplyDetailDto.setPayingStatusStr("缴费中");
            }else if(studentApplyDetailDto.getPayingStatus().equals(2)){
                studentApplyDetailDto.setPayingStatusStr("审核中");
            }
        }
        return studentApplyDetail;
    }

    //评论列表导出
    @Override
    public List courseReviews(Map<String, Object> info){
        CourseReviewQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),CourseReviewQueryInfo.class);
        PageInfo<CourseReviewDto> practiceGroupReviews = courseReviewService.getVipCourseReviews(queryInfo);
        if (practiceGroupReviews.getTotal() <= 0) {
            throw new BizException("没有可导出的记录");
        }
        for (CourseReviewDto row : practiceGroupReviews.getRows()) {
            row.setClassDateStr(DateUtil.dateToString(row.getClassDate(), "yyyy-MM-dd"));
            if (row.getHandHomework() != null && row.getHandHomework() > 0) {
                row.setHandHomeworkStr("是");
            } else {
                row.setHandHomeworkStr("否");
            }
            if (row.getHasLiaison() != null && row.getHasLiaison().equals("1")) {
                row.setHasLiaison("是");
            } else {
                row.setHasLiaison("否");
            }
            if (row.getCreateTime() != null) {
                row.setCreateTimeStr(DateUtil.dateToString(row.getCreateTime(), "yyyy-MM-dd"));
            }
            if (row.getPronunciation() != null) {
                row.setPronunciationStr(row.getPronunciation() + "星");
            }
            if (row.getTempo() != null) {
                row.setTempoStr(row.getTempo() + "星");
            }
            if (row.getMusicTheory() != null) {
                row.setMusicTheoryStr(row.getMusicTheory() + "星");
            }
            if (row.getHomeWorkReplied() != null && row.getHomeWorkReplied().equals("1")) {
                row.setHomeWorkReplied("已回复");
            } else if (row.getHandHomework() != null && row.getHandHomework() > 0) {
                row.setHomeWorkReplied("未回复");
            } else {
                row.setHomeWorkReplied(null);
            }
            if (row.getAttendanceId() != null) {
                row.setAttendanceStr("是");
            } else {
                row.setAttendanceStr("否");
            }
            if (new Integer(1).equals(row.getAssignHomework())) {
                row.setAssignHomeworkStr("是");
            } else {
                row.setAssignHomeworkStr("否");
            }
        }
        return practiceGroupReviews.getRows();
    }

    //乐团管理--乐团详情-导出学员列表
    @Override
    public List queryMusicGroupStudent(Map<String, Object> info){
        MusicGroupStudentQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),MusicGroupStudentQueryInfo.class);
        PageInfo<MusicGroupStudentsDto> musicGroupStudentsDtoPageInfo = studentManageService.queryMusicGroupStudent(queryInfo);
        //获取分部年级列表
        MusicGroup musicGroup = musicGroupDao.get(queryInfo.getMusicGroupId());
        Map<Integer, String> gradeList = organizationService.getGradeList(musicGroup.getOrganId());
        for (MusicGroupStudentsDto row : musicGroupStudentsDtoPageInfo.getRows()) {
            if(StringUtils.isNotEmpty(row.getCurrentGrade())){
                String grade = gradeList.get(Integer.parseInt(row.getCurrentGrade()));
                if(StringUtils.isNotEmpty(grade)){
                    row.setCurrentGrade(grade);
                }
            }
            if (row.getGender() != null) {
                if (row.getGender().equals("1")) {
                    row.setGender("男");
                } else {
                    row.setGender("女");
                }
            }
            if (row.getStudentStatus().equals("NORMAL")) {
                row.setStudentStatus("在读");
            } else if (row.getStudentStatus().equals("QUIT")) {
                row.setStudentStatus("退团");
            } else if (row.getStudentStatus().equals("APPLY")) {
                row.setStudentStatus("报名");
            } else {
                row.setStudentStatus("" + row.getStudentStatus());
            }
            if (row.getIsActive()) {
                row.setActiveName("是");
            } else {
                row.setActiveName("否");
            }
            if (row.getMusicMembershipDay() != null && row.getMusicMembershipDay() < 0) {
                row.setMusicMembershipDay1(Math.abs(row.getMusicMembershipDay()));
            }
            if (row.getNextPaymentDate() != null) {
                row.setNextPaymentDateStr(DateUtil.format(row.getNextPaymentDate(), DateUtil.DEFAULT_PATTERN));
            }
        }
        return musicGroupStudentsDtoPageInfo.getRows();
    }

    //网管课管理导出
    @Override
    public List practiceGroup() {
        String organIds = organizationService.getEmployeeOrgan("");
        List<CourseGroupExportDto> practiceGroupExports = practiceGroupDao.getPracticeGroupExport(organIds, TenantContextHolder.getTenantId());
        if (practiceGroupExports == null || practiceGroupExports.size() == 0) {
            throw new BizException("没有可导出的记录");
        }
        Set<Integer> studentIds = practiceGroupExports.stream().map(CourseGroupExportDto::getStudentId).collect(Collectors.toSet());
        List<CourseGroupExportDto> studentCourseInfos = courseScheduleDao.getStudentCourseInfo(studentIds, GroupType.PRACTICE);

        List<CourseGroupExportDto> totalClassTimes = courseScheduleDao.getStudentCourseScheduleNum(studentIds, GroupType.PRACTICE, null);
        List<CourseGroupExportDto> noStartClassTimes = courseScheduleDao.getStudentCourseScheduleNum(studentIds, GroupType.PRACTICE, CourseStatusEnum.NOT_START);
        for (CourseGroupExportDto practiceGroupExport : practiceGroupExports) {
            for (CourseGroupExportDto studentCourseInfo : studentCourseInfos) {
                if (studentCourseInfo.getStudentId().equals(practiceGroupExport.getStudentId())) {
                    practiceGroupExport.setTeacherIds(studentCourseInfo.getTeacherIds());
                    practiceGroupExport.setTeacherName(studentCourseInfo.getTeacherName());
                    practiceGroupExport.setClassEndDate(studentCourseInfo.getClassEndDate());
                    break;
                }
            }

            for (CourseGroupExportDto studentTotalClassTimes : totalClassTimes) {
                if (studentTotalClassTimes.getStudentId().equals(practiceGroupExport.getStudentId())) {
                    practiceGroupExport.setTotalClassTimes(studentTotalClassTimes.getTotalClassTimes());
                    break;
                }
            }
            for (CourseGroupExportDto noStartStudentClassTimes : noStartClassTimes) {
                if (noStartStudentClassTimes.getStudentId().equals(practiceGroupExport.getStudentId())) {
                    practiceGroupExport.setNoStartClassTimes(noStartStudentClassTimes.getTotalClassTimes());
                    break;
                }
            }
        }
        return practiceGroupExports;
    }

    //vip管理导出
    @Override
    public List vipGroup(){
        List<CourseGroupExportDto> vipGroupExports = courseScheduleDao.getVipGroupExport(organizationService.getEmployeeOrgan(""));
        if (vipGroupExports == null || vipGroupExports.size() == 0) {
            throw new BizException("没有可导出的记录");
        }
        Set<Integer> studentIds = vipGroupExports.stream().map(CourseGroupExportDto::getStudentId).collect(Collectors.toSet());
        List<Map<Integer, Date>> studentLastCourseSchedule = courseScheduleStudentPaymentDao.findStudentLastCourseSchedule(new ArrayList<>(studentIds));
        Map<Integer, String> studentLastCourseMap = new HashMap<>();
        if (!CollectionUtils.isEmpty(studentLastCourseSchedule)) {
            studentLastCourseMap = MapUtil.convertMybatisMap(studentLastCourseSchedule);
        }
        List<CourseGroupExportDto> studentCourseInfos = courseScheduleDao.getStudentVipCourseInfo(studentIds);
        List<CourseGroupExportDto> totalClassTimes = courseScheduleDao.getStudentCourseScheduleNum(studentIds, GroupType.VIP, null);
        List<CourseGroupExportDto> noStartClassTimes = courseScheduleDao.getStudentCourseScheduleNum(studentIds, GroupType.VIP, CourseStatusEnum.NOT_START);
        for (CourseGroupExportDto vipGroupExport : vipGroupExports) {

            String lastClassDateStr = studentLastCourseMap.get(vipGroupExport.getStudentId());
            if (StringUtils.isNotBlank(lastClassDateStr)) {
                vipGroupExport.setLastClassDate(DateUtil.stringToDate(lastClassDateStr));
            }

            for (CourseGroupExportDto studentCourseInfo : studentCourseInfos) {
                if (studentCourseInfo.getStudentId().equals(vipGroupExport.getStudentId())) {
                    vipGroupExport.setTeacherIds(studentCourseInfo.getTeacherIds());
                    vipGroupExport.setTeacherName(studentCourseInfo.getTeacherName());
                    vipGroupExport.setClassStartDate(studentCourseInfo.getClassStartDate());
                    vipGroupExport.setClassEndDate(studentCourseInfo.getClassEndDate());
                    break;
                }
            }
            for (CourseGroupExportDto studentTotalClassTimes : totalClassTimes) {
                if (studentTotalClassTimes.getStudentId().equals(vipGroupExport.getStudentId())) {
                    vipGroupExport.setTotalClassTimes(studentTotalClassTimes.getTotalClassTimes());
                    break;
                }
            }
            for (CourseGroupExportDto noStartStudentClassTimes : noStartClassTimes) {
                if (noStartStudentClassTimes.getStudentId().equals(vipGroupExport.getStudentId())) {
                    vipGroupExport.setNoStartClassTimes(noStartStudentClassTimes.getTotalClassTimes());
                    break;
                }
            }
        }
        return vipGroupExports;
    }

    //学生课外训练记录导出
    @Override
    public List extraExercisesReplys(Map<String, Object> info){
        ExtraExercilseReplyQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),ExtraExercilseReplyQueryInfo.class);
        queryInfo.setOrganIdList(organizationService.getEmployeeOrgan(queryInfo.getOrganIdList()));
        List<ExtraExerciseStudentsDto> rows = extracurricularExercisesReplyService.findExtraExercises(queryInfo).getRows();
        if (CollectionUtils.isEmpty(rows)) {
            throw new BizException("没有可导出的记录");
        }
        for (ExtraExerciseStudentsDto row : rows) {
            row.setStatusStr(Objects.isNull(row.getStatus()) || row.getStatus() == 0 ? "否" : "是");
            row.setIsViewStr(Objects.isNull(row.getIsView()) || row.getIsView() == 0 ? "否" : "是");
            row.setIsRepliedStr(Objects.isNull(row.getIsReplied()) || row.getIsReplied() == 0 ? "否" : "是");
            row.setIsRepliedTimelyStr(Objects.isNull(row.getIsRepliedTimely()) || row.getIsRepliedTimely() == 0 ? "否" : "是");
            row.setExistVipCourseStr(Objects.isNull(row.getExistVipCourse()) || row.getExistVipCourse() == 0 ? "否" : "是");
        }
        return rows;
    }

    //教师课酬导出
    @Override
    public List isSettlementCourseSalarys(Map<String, Object> info){
        CourseSalaryQueryInfo4Web queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),CourseSalaryQueryInfo4Web.class);
        queryInfo.setOrganIdList(organizationService.getEmployeeOrgan(queryInfo.getOrganIdList()));
        List<TeacherCourseSalaryDetail4WebDto> rows = courseScheduleTeacherSalaryService.findIsSettlementCourseSalarys(queryInfo).getRows();
        if (CollectionUtils.isEmpty(rows)) {
            throw new BizException("没有可导出的记录");
        }
        for (TeacherCourseSalaryDetail4WebDto row : rows) {
            if (Objects.isNull(row.getSignInTime())) {
                row.setSignInStatusStr("未签到");
            } else {
                String signInTimeStr = DateUtil.dateToString(row.getSignInTime(), "yyyy-MM-dd HH:mm");
                if (YesOrNoEnum.YES.equals(row.getSignInStatus())) {
                    row.setSignInStatusStr(signInTimeStr + "(正常签到)");
                } else {
                    row.setSignInStatusStr(signInTimeStr + "(异常签到)");
                }
            }
            if (Objects.isNull(row.getSignOutTime())) {
                row.setSignOutStatusStr("未签退");
            } else {
                String signOutTimeStr = DateUtil.dateToString(row.getSignOutTime(), "yyyy-MM-dd HH:mm");
                if (YesOrNoEnum.YES.equals(row.getSignOutStatus())) {
                    row.setSignOutStatusStr(signOutTimeStr + "(正常签退)");
                } else {
                    row.setSignOutStatusStr(signOutTimeStr + "(异常签退)");
                }
            }
            if (row.getBelongDaya() == 1) {
                row.setSalaryType("基本课酬");
            } else {
                row.setSalaryType("其它课酬");
            }
        }
        return rows;
    }

    //运营指标管理导出
    @Override
    public List operatingStudents(Map<String, Object> info) {
        StudentOperatingQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),StudentOperatingQueryInfo.class);
        queryInfo.setOrganId(organizationService.getEmployeeOrgan(queryInfo.getOrganId()));
        PageInfo<Student4operating> PageOperatingStudents = studentManageService.getOperatingStudents(queryInfo);

        if (PageOperatingStudents.getTotal() <= 0) {
            throw new BizException("导出记录不存在");
        }
        List<Student4operating> rows = PageOperatingStudents.getRows();
        for (Student4operating row : rows) {
            if (row.getOperatingTag() != null && row.getOperatingTag() == 1) {
                row.setOperatingTagStr("是");
            } else {
                row.setOperatingTagStr("否");
            }
            if (row.getVipTimes() != null && row.getVipTimes() > 0) {
                row.setVipTimesStr("是");
            } else {
                row.setVipTimesStr("否");
            }
            if (row.getMusicNetWorkTimes() != null && row.getMusicNetWorkTimes() > 0) {
                row.setMusicNetWorkTimesStr("是");
            } else {
                row.setMusicNetWorkTimesStr("否");
            }
            if (row.getFreePracticeTimes() != null && row.getFreePracticeTimes() > 0) {
                row.setFreePracticeTimesStr("是");
            } else {
                row.setFreePracticeTimesStr("否");
            }
            if (row.getBuyPracticeTimes() != null && row.getBuyPracticeTimes() > 0) {
                row.setBuyPracticeTimesStr("是");
            } else {
                row.setBuyPracticeTimesStr("否");
            }
        }
        return rows;
    }

    //vip评论列表导出
    @Override
    public List vipCourseReviews(Map<String, Object> info){
        CourseReviewQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),CourseReviewQueryInfo.class);
        queryInfo.setOrganId(organizationService.getEmployeeOrgan(queryInfo.getOrganId()));
        queryInfo.setIsExport(1);
        PageInfo<CourseReviewDto> practiceGroupReviews = courseReviewService.getVipCourseReviews(queryInfo);
        if (practiceGroupReviews.getTotal() <= 0) {
            throw new BizException("没有可导出的记录");
        }
        for (CourseReviewDto row : practiceGroupReviews.getRows()) {
            row.setClassDateStr(DateUtil.dateToString(row.getClassDate(), "yyyy-MM-dd"));
            if (row.getHandHomework() != null && row.getHandHomework() > 0) {
                row.setHandHomeworkStr("是");
            } else {
                row.setHandHomeworkStr("否");
            }
            if (row.getHasLiaison() != null && row.getHasLiaison().equals("1")) {
                row.setHasLiaison("是");
            } else {
                row.setHasLiaison("否");
            }
            if (row.getCreateTime() != null) {
                row.setCreateTimeStr(DateUtil.dateToString(row.getCreateTime(), "yyyy-MM-dd"));
            }
            if (row.getPronunciation() != null) {
                row.setPronunciationStr(row.getPronunciation() + "星");
            }
            if (row.getTempo() != null) {
                row.setTempoStr(row.getTempo() + "星");
            }
            if (row.getMusicTheory() != null) {
                row.setMusicTheoryStr(row.getMusicTheory() + "星");
            }
            if (row.getHomeWorkReplied() != null && row.getHomeWorkReplied().equals("1")) {
                row.setHomeWorkReplied("已回复");
            } else if (row.getHandHomework() != null && row.getHandHomework() > 0) {
                row.setHomeWorkReplied("未回复");
            } else {
                row.setHomeWorkReplied(null);
            }
            if (row.getAttendanceId() != null) {
                row.setAttendanceStr("是");
            } else {
                row.setAttendanceStr("否");
            }
            if (new Integer(1).equals(row.getAssignHomework())) {
                row.setAssignHomeworkStr("是");
            } else {
                row.setAssignHomeworkStr("否");
            }
        }
        return practiceGroupReviews.getRows();
    }

    //考级报名导出
    @Override
    public List degreeRegistration(Map<String, Object> info) {
        DegreeQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),DegreeQueryInfo.class);
        queryInfo.setSort("create_time_");
        queryInfo.setOrder("ASC");
        return degreeRegistrationService.getPageList(queryInfo).getRows();
    }

    //回款统计
    @Override
    public List studentOrder(Map<String, Object> info){
        String organIds = getParam(info,"organIds",String.class);
        Date date = DateUtil.stringToDate(getParam(info,"date",String.class),DateUtil.ISO_EXPANDED_DATE_FORMAT);
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        organIds = organizationService.getEmployeeOrgan(sysUser.getId(), organIds, sysUser.getIsSuperAdmin());
        Date startTime = DateUtil.getFirstDayOfMonth(date);
        Date EndTime = DateUtil.getLastSecondWithDay(DateUtil.getLastDayOfMonth(date));

        List<OrderTypeEnum> orderTypeList = new ArrayList<>();
        orderTypeList.add(OrderTypeEnum.SPORADIC);
        orderTypeList.add(OrderTypeEnum.PRACTICE_GROUP_BUY);
        orderTypeList.add(OrderTypeEnum.PRACTICE_GROUP_RENEW);
        orderTypeList.add(OrderTypeEnum.SMALL_CLASS_TO_BUY);
        List<OrderByTypeExportDto> orders = studentPaymentOrderDao.getOrderByMonthAndType(organIds, orderTypeList, startTime, EndTime);

        if (orders.size() <= 0) {
            throw new BizException("没有可导出的记录");
        }
        List<Long> vipGroupIds = orders.stream().filter(e -> e.getGroupType().equals(GroupType.VIP)).map(OrderByTypeExportDto::getMusicGroupId).collect(Collectors.toList());
        List<Long> practiceGroupIds = orders.stream().filter(e -> e.getGroupType().equals(GroupType.PRACTICE)).map(OrderByTypeExportDto::getMusicGroupId).collect(Collectors.toList());
        List<Integer> studentIds = orders.stream().filter(e -> e.getGroupType().equals(GroupType.SPORADIC)).map(OrderByTypeExportDto::getStudentId).collect(Collectors.toList());

        List<VipBuyResultDto> vipGroupTeachers = new ArrayList<>();
        List<PracticeCourseDto> practiceGroupsTeacher = new ArrayList<>();
        List<Student> studentTeachers = new ArrayList<>();
        if (vipGroupIds.size() > 0) {
            vipGroupTeachers = vipGroupDao.getGroupTeachers(vipGroupIds, TenantContextHolder.getTenantId());
        }

        if (practiceGroupIds.size() > 0) {
            practiceGroupsTeacher = practiceGroupDao.getPracticeGroupByIds(practiceGroupIds);
        }
        if (studentIds.size() > 0) {
            studentTeachers = studentDao.getStudentTeacher(studentIds);
        }

        for (OrderByTypeExportDto order : orders) {
            for (VipBuyResultDto vipGroupTeacher : vipGroupTeachers) {
                if (order.getGroupType().equals(GroupType.VIP) && order.getMusicGroupId().equals(vipGroupTeacher.getVipGroupId().longValue())) {
                    order.setTeacherName(vipGroupTeacher.getTeacherName());
                    order.setEduTeacherName(vipGroupTeacher.getEduTeacherName());
                    break;
                }
            }
            for (PracticeCourseDto practiceCourseDto : practiceGroupsTeacher) {
                if (order.getGroupType().equals(GroupType.PRACTICE) && order.getMusicGroupId().equals(practiceCourseDto.getId())) {
                    order.setTeacherName(practiceCourseDto.getTeacherName());
                    order.setEduTeacherName(practiceCourseDto.getEduTeacherName());
                    break;
                }
            }
            for (Student studentTeacher : studentTeachers) {
                if (order.getGroupType().equals(GroupType.SPORADIC) && studentTeacher.getUserId().equals(order.getStudentId())) {
                    order.setTeacherName(studentTeacher.getTeacherName());
                    break;
                }
            }
        }
        return orders;
    }

    //销售列表导出
    @Override
    public List exportSellOrders(Map<String, Object> info){
        SellOrderQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),SellOrderQueryInfo.class);
        queryInfo.setOrganIdList(organizationService.getEmployeeOrgan(queryInfo.getOrganIdList()));
        if (queryInfo.getEndTime() != null) {
            queryInfo.setEndTime(DateUtil.getLastTimeWithDay(queryInfo.getEndTime()));
        }
        List<SellOrder> rows = sellOrderService.queryPage(queryInfo).getRows();
        for (SellOrder row : rows) {
            if (StringUtils.isNoneBlank(row.getPaymentChannel())) {
                row.setPaymentChannelStr(PaymentChannelEnum.valueOf(row.getPaymentChannel()).getDesc());
            }
            row.setAccountTypeStr(AccountType.INTERNAL.equals(row.getAccountType()) ? "对内" : "对外");
            switch (row.getReceiveStatus()) {
                case "NO_RECEIVE":
                    row.setReceiveStatusStr("未确认");
                    break;
                case "MANUAL_RECEIVE":
                    row.setReceiveStatusStr("手动确认");
                    break;
                case "AUTO_RECEIVE":
                    row.setReceiveStatusStr("自动确认");
                    break;
            }
            row.setOrderAmount(row.getExpectAmount().add(row.getCouponRemitAmount()));
        }
        return rows;
    }

    //服务指标明细导出
    @Override
    public List teacherServeInfo(Map<String, Object> info){
        TeacherServeQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),TeacherServeQueryInfo.class);
        queryInfo.setOrganId(organizationService.getEmployeeOrgan(queryInfo.getOrganId()));
        PageInfo<TeacherServeDto> result = studentExtracurricularExercisesSituationService.queryTeacherServeInfo(queryInfo);
        if (CollectionUtils.isEmpty(result.getRows())) {
            throw new BizException("没有可导出的记录");
        }
        BigDecimal oneHundred = new BigDecimal(100);
        BigDecimal zero = new BigDecimal("0.00");
        for (TeacherServeDto row : result.getRows()) {
            row.setDateRange(com.ym.mec.util.date.DateUtil.dateToString(row.getMonday(), "yyyy-MM-dd") + '~' + com.ym.mec.util.date.DateUtil.dateToString(row.getSunday(), "yyyy-MM-dd"));
            if (row.getActualExercisesNum() <= 0) {
                row.setSubmitRate(zero.toString() + "%");
            } else {
                BigDecimal submitRate = new BigDecimal(row.getExercisesReplyNum()).divide(new BigDecimal(row.getActualExercisesNum()), CommonConstants.DECIMAL_FINAL_PLACE, BigDecimal.ROUND_HALF_UP).multiply(oneHundred);
                row.setSubmitRate(submitRate + "%");
            }
        }
        return result.getRows();
    }

    //首页异常统计导出
    @Override
    public List exportIndexErrData(Map<String, Object> info){
        String organId = getParam(info,"organId",String.class);
        IndexErrorType errorType = getParam(info,"errorType",IndexErrorType.class);
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        if (sysUser == null) {
            throw new BizException("用户信息获取失败");
        }
        organId = organizationService.getEmployeeOrgan(sysUser.getId(), organId, sysUser.getIsSuperAdmin());
        List<IndexErrorDataExportDto> result = indexService.exportIndexErrData(organId, errorType);
        if (CollectionUtils.isEmpty(result)) {
            throw new BizException("没有可导出的记录");
        }
        return result;
    }

    //分部云教练学员数据预览导出
    @Override
    public List organStudentOverView(Map<String, Object> info){
        OrganCloudStudyStudentDataQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),OrganCloudStudyStudentDataQueryInfo.class);
        String organIds = organizationService.getEmployeeOrgan("");
        if (StringUtils.isEmpty(organIds)) {
            throw new BizException("没有可导出的记录");
        }
        List<Integer> collect = Arrays.stream(organIds.split(",")).mapToInt(Integer::parseInt).boxed().collect(Collectors.toList());
        List<Integer> ids = collect.stream().filter(id -> !OrganizationService.EXCLUDE_ORGAN_IDS.contains(id)).collect(Collectors.toList());
        if (ids == null || ids.size() == 0) {
            throw new BizException("没有可导出的记录");
        }
        List<EduOrganStudentDataDto> rows = studentService.queryOrganStudentOverView(ids, queryInfo).getRows();
        if (CollectionUtils.isEmpty(rows)) {
            throw new BizException("没有可导出的记录");
        }
        return rows;
    }

    //分部云教练学员训练数据导出
    @Override
    public List cloudStudyStudentTrainData(Map<String, Object> info){
        StudentQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),StudentQueryInfo.class);
        List<EduOrganStudentListExportDto> rows = ((PageInfo<EduOrganStudentListExportDto>) studentService.exportOrganStudentData(queryInfo).getDetail()).getRows();
        if (CollectionUtils.isEmpty(rows)) {
            throw new BizException("没有可导出的记录");
        }
        for (EduOrganStudentListExportDto row : rows) {
            row.setCloudStudyUseTime(Math.round(row.getCloudStudyUseTime()));
            row.setCloudStudyUseAvgTime(Math.round(row.getCloudStudyUseAvgTime()));
        }
        return rows;
    }

    //分部云教练学员数据详情导出
    @Override
    public List cloudStudyStudentOverView(Map<String, Object> info){
        OrganCloudStudyStudentDataQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),OrganCloudStudyStudentDataQueryInfo.class);
        String organIds = organizationService.getEmployeeOrgan("");
        if (StringUtils.isEmpty(organIds)) {
            throw new BizException("没有可导出的记录");
        }
        List<Integer> collect = Arrays.stream(organIds.split(",")).mapToInt(Integer::parseInt).boxed().collect(Collectors.toList());
        List<Integer> ids = collect.stream().filter(id -> !OrganizationService.EXCLUDE_ORGAN_IDS.contains(id)).collect(Collectors.toList());
        if (ids == null || ids.size() == 0) {
            throw new BizException("没有可导出的记录");
        }
        List<EduOrganStudentDataDto> rows = indexService.organStudentOverView(ids, queryInfo).getRows();
        if (CollectionUtils.isEmpty(rows)) {
            throw new BizException("没有可导出的记录");
        }
        return rows;
    }

    //乐团声部在读人数导出
    @Override
    public void musicGroupNormalStudentNum(HttpServletResponse response, ExportDto exportDto) throws IOException {
        String organIds = getParam(exportDto.getQueryInfo(),"organIds",String.class);
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        organIds = organizationService.getEmployeeOrgan(sysUser.getId(),organIds,sysUser.getIsSuperAdmin());

        List<MusicGroupStatusEnum> musicGroupStatusList = new ArrayList<>();
        musicGroupStatusList.add(MusicGroupStatusEnum.PAY);
        musicGroupStatusList.add(MusicGroupStatusEnum.PREPARE);
        musicGroupStatusList.add(MusicGroupStatusEnum.PROGRESS);
        musicGroupStatusList.add(MusicGroupStatusEnum.PAUSE);
        List<MusicGroupRegisterDto> musicGroupRegisters = musicGroupDao.getMusicGroupRegister(musicGroupStatusList, organIds, TenantContextHolder.getTenantId());

        if (musicGroupRegisters.size() <= 0) {
            throw new BizException("没有可导出的记录");
        }
        List<String> musicGroupIds = musicGroupRegisters.stream().map(MusicGroupRegisterDto::getMusicGroupId).collect(Collectors.toList());

        List<RegisterSubjectDto> registerSubjects = musicGroupDao.getRegisterSubjectNum(musicGroupIds, StudentMusicGroupStatusEnum.NORMAL, null);

        HashSet<Integer> added = new HashSet<>();
        //获取用户选择的表头和表字段
        Map<String, String> exportMap = getExportMap(exportDto);
        Set<String> header = new LinkedHashSet<>(exportMap.keySet());
        Set<String> body = new LinkedHashSet<>(exportMap.values());
        for (RegisterSubjectDto registerSubject : registerSubjects) {
            if (!added.contains(registerSubject.getSubjectId())) {
                added.add(registerSubject.getSubjectId());
                header.add(registerSubject.getSubjectName());
                body.add("subject" + registerSubject.getSubjectId());
            }
        }

        List<Map<String, Object>> data = new ArrayList<>();
        for (MusicGroupRegisterDto musicGroupRegister : musicGroupRegisters) {
            added.clear();
            HashMap<String, Object> musicGroupRegisterMap = new HashMap<>();

            musicGroupRegisterMap.put("organName", musicGroupRegister.getOrganName());
            musicGroupRegisterMap.put("musicGroupName", musicGroupRegister.getMusicGroupName());
            musicGroupRegisterMap.put("musicGroupStatus", musicGroupRegister.getMusicGroupStatus().getMsg());
            musicGroupRegisterMap.put("normalNum", musicGroupRegister.getNormalNum());

            for (RegisterSubjectDto registerSubject : registerSubjects) {
                if (registerSubject.getMusicGroupId().equals(musicGroupRegister.getMusicGroupId())) {
                    added.add(registerSubject.getSubjectId());
                    musicGroupRegisterMap.put("subject" + registerSubject.getSubjectId(), registerSubject.getNum());
                }
                if (!added.contains(registerSubject.getSubjectId())) {
                    musicGroupRegisterMap.put("subject" + registerSubject.getSubjectId(), 0);
                }
            }
            data.add(musicGroupRegisterMap);
        }

        OutputStream outputStream = response.getOutputStream();
        try {
            String[] headerStr = header.toArray(new String[header.size()]);
            String[] bodyStr = body.toArray(new String[body.size()]);

            HSSFWorkbook workbook = POIUtil.exportExcel(headerStr, bodyStr, data);
            response.setContentType("application/octet-stream");
            response.setHeader("Content-Disposition", "attachment;filename=lender-" + DateUtil.getDate(new Date()) + ".xls");

            outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (outputStream != null) {
                try {
                    outputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    //分部云教练活动统计数据导出
    @Override
    public List countCloudTeacherActive(Map<String, Object> info){
        CloudTeacherActiveQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),CloudTeacherActiveQueryInfo.class);
        String organIds = organizationService.getEmployeeOrgan("");
        if (StringUtils.isEmpty(organIds)) {
            throw new BizException("没有可导出的记录");
        }
        List<Integer> collect = Arrays.stream(organIds.split(",")).mapToInt(Integer::parseInt).boxed().collect(Collectors.toList());
        List<Integer> ids = collect.stream().filter(id -> !OrganizationService.EXCLUDE_ORGAN_IDS.contains(id)).collect(Collectors.toList());
        if (ids == null || ids.size() == 0) {
            throw new BizException("没有可导出的记录");
        }
        Object object = studentService.countCloudTeacherActive(ids, queryInfo).get("resultList");
        if (object == null) {
            throw new BizException("没有可导出的记录");
        }
        return (List<CloudTeacherActiveTargetDto>) object;
    }

    //云教练活动统计详情
    @Override
    public List countCloudTeacherActiveDetail(Map<String, Object> info){
        CloudTeacherActiveQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),CloudTeacherActiveQueryInfo.class);
        List<CloudTeacherActiveTargetDetailDto> rows = studentService.countCloudTeacherActiveDetail(queryInfo).getRows();
        if (CollectionUtils.isEmpty(rows)) {
            throw new BizException("没有可导出的记录");
        }
        //获取分部年级列表
        Map<Integer, String> gradeList = organizationService.getGradeList(Integer.parseInt(queryInfo.getOrganIds()));
        for (CloudTeacherActiveTargetDetailDto row : rows) {
            if (StringUtils.isNotEmpty(row.getCurrentGradeNum())) {
                String grade = gradeList.get(Integer.parseInt(row.getCurrentGradeNum()));
                if (StringUtils.isNotEmpty(grade)) {
                    row.setCurrentGradeNum(grade);
                }
            }
        }
        return rows;
    }

    @Override
    public <T> T getQueryInfo(Map<String, Object> info, Class<T> clazz, Boolean organFlag){
        if(organFlag){
            info.put("organId",organizationService.getEmployeeOrgan(info.get("organId")));
        }
        return JSONObject.parseObject(JSONObject.toJSONString(info), clazz);
    }

    @Override
    public <T> T getParam(Map<String, Object> info, String key, Class<T> clazz){
        try {
            return info.get(key)==null?clazz.newInstance():(T)(info.get(key));
        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
        return null;
    }


    //报名中缴费中乐团缴费情况导出
    @Override
    public void musicGroupRegister(HttpServletResponse response, ExportDto exportDto) throws IOException {
        String organIds = getParam(exportDto.getQueryInfo(),"organIds",String.class);
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        organIds = organizationService.getEmployeeOrgan(sysUser.getId(),organIds,sysUser.getIsSuperAdmin());
        List<MusicGroupStatusEnum> musicGroupStatusList = new ArrayList<>();
        musicGroupStatusList.add(MusicGroupStatusEnum.APPLY);
        musicGroupStatusList.add(MusicGroupStatusEnum.PAY);

        List<MusicGroupRegisterDto> musicGroupRegisters = musicGroupDao.getMusicGroupRegister(musicGroupStatusList, organIds, TenantContextHolder.getTenantId());

        if (musicGroupRegisters.size() <= 0) {
            throw new BizException("没有可导出的记录");
        }
        List<String> musicGroupIds = musicGroupRegisters.stream().map(MusicGroupRegisterDto::getMusicGroupId).collect(Collectors.toList());

        List<RegisterSubjectDto> registerSubjects = musicGroupDao.getRegisterSubjectNum(musicGroupIds, null, 2);
        List<MusicGroupRegisterDto> musicGroupRegisterOrders = musicGroupDao.getMusicGroupRegisterOrder(musicGroupIds);
        List<MusicGroupRegisterDto> musicGroupRegisterTotalMoneys = musicGroupDao.getMusicGroupRegisterTotalMoney(musicGroupIds);

        List<MusicGroupBuildLog> musicGroupAuditSuccess = musicGroupBuildLogDao.getMusicGroupAuditSuccess(musicGroupIds);
        HashSet<Integer> added = new HashSet<>();
        //获取用户选择的表头和表字段
        Map<String, String> exportMap = getExportMap(exportDto);
        Set<String> header = new LinkedHashSet<>(exportMap.keySet());
        Set<String> body = new LinkedHashSet<>(exportMap.values());
        for (RegisterSubjectDto registerSubject : registerSubjects) {
            if (!added.contains(registerSubject.getSubjectId())) {
                added.add(registerSubject.getSubjectId());
                header.add(registerSubject.getSubjectName());
                body.add("subject" + registerSubject.getSubjectId());
            }
        }
        List<Map<String, Object>> data = new ArrayList<>();
        for (MusicGroupRegisterDto musicGroupRegister : musicGroupRegisters) {
            added.clear();
            HashMap<String, Object> musicGroupRegisterMap = new HashMap<>();
            int registerPayNum = 0;
            musicGroupRegisterMap.put("organName", musicGroupRegister.getOrganName());
            musicGroupRegisterMap.put("musicGroupName", musicGroupRegister.getMusicGroupName());
            musicGroupRegisterMap.put("musicGroupStatus", musicGroupRegister.getMusicGroupStatus().getMsg());
            musicGroupRegisterMap.put("registerNum", musicGroupRegister.getRegisterNum());
            for (MusicGroupRegisterDto musicGroupRegisterOrder : musicGroupRegisterOrders) {
                if (musicGroupRegisterOrder.getMusicGroupId().equals(musicGroupRegister.getMusicGroupId())) {
                    musicGroupRegister.setGroupBuyMusicalNum(musicGroupRegisterOrder.getGroupBuyMusicalNum());
                }
            }
            for (MusicGroupRegisterDto musicGroupRegisterTotalMoney : musicGroupRegisterTotalMoneys) {
                if (musicGroupRegisterTotalMoney.getMusicGroupId().equals(musicGroupRegister.getMusicGroupId())) {
                    musicGroupRegister.setTotalMoney(musicGroupRegisterTotalMoney.getTotalMoney());
                }
            }

            for (RegisterSubjectDto registerSubject : registerSubjects) {
                if (registerSubject.getMusicGroupId().equals(musicGroupRegister.getMusicGroupId())) {
                    added.add(registerSubject.getSubjectId());
                    musicGroupRegisterMap.put("subject" + registerSubject.getSubjectId(), registerSubject.getNum());
                    registerPayNum += registerSubject.getNum();
                }
                if (!added.contains(registerSubject.getSubjectId())) {
                    musicGroupRegisterMap.put("subject" + registerSubject.getSubjectId(), 0);
                }
            }
            for (MusicGroupBuildLog groupAuditSuccess : musicGroupAuditSuccess) {
                if (!groupAuditSuccess.getMusicGroupId().equals(musicGroupRegister.getMusicGroupId())) continue;
                musicGroupRegisterMap.put("auditSuccessTime", groupAuditSuccess.getCreateTime());
            }
            musicGroupRegisterMap.put("groupBuyMusicalNum", musicGroupRegister.getGroupBuyMusicalNum());
            musicGroupRegisterMap.put("registerPayNum", registerPayNum);
            musicGroupRegisterMap.put("totalMoney", musicGroupRegister.getTotalMoney());
            data.add(musicGroupRegisterMap);
        }

        OutputStream outputStream = response.getOutputStream();
        try {
            String[] headerStr = header.toArray(new String[header.size()]);
            String[] bodyStr = body.toArray(new String[body.size()]);

            HSSFWorkbook workbook = POIUtil.exportExcel(headerStr, bodyStr, data);
            response.setContentType("application/octet-stream");
            response.setHeader("Content-Disposition", "attachment;filename=lender-" + DateUtil.getDate(new Date()) + ".xls");

            outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (outputStream != null) {
                try {
                    outputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    //财务管理导出
    @Override
    public HttpResponseResult routeOrderList(Map<String, Object> info,List<String> headColumns){
        StudentPaymentOrderQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),StudentPaymentOrderQueryInfo.class);
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        if (sysUser == null || sysUser.getId() == null) {
            return BaseController.failed(HttpStatus.FORBIDDEN, "请登录");
        }
        queryInfo.setOrganId(organizationService.getEmployeeOrgan(sysUser.getId(),queryInfo.getOrganId(),sysUser.getIsSuperAdmin()));
        if (StringUtils.isNotBlank(queryInfo.getSearch())) {
            List<BasicUserDto> users = studentPaymentOrderDao.getUsers(queryInfo.getSearch());
            List<Integer> userIds = users.stream().map(BasicUserDto::getUserId).collect(Collectors.toList());
            if (userIds.size() <= 0) {
                userIds.add(0);
            }
            queryInfo.setUserIds(userIds);
        }
        queryInfo.setOrderType("3");
        Map<String, Object> params = new HashMap<>();
        MapUtil.populateMap(params, queryInfo);
        int count = studentPaymentRouteOrderDao.queryCount(params);
        if (count <= 0) {
            return BaseController.failed("没有可导出的数据");
        }
        if (count > 50000) {
            return BaseController.failed("数据集太大，不能导出.最大数据集不能超过50000");
        }
        queryInfo.setRoutingOrganId(null);
        ManagerDownload managerDownload = saveManagerDownload(ExportTypeEnum.ROUTE_ORDER,sysUser.getId());
        try {
            this.routeOrderList(params, managerDownload, headColumns);
        } catch (FileNotFoundException e) {
            return BaseController.failed(e.getMessage());
        }
        HttpResponseResult<Object> succeed = BaseController.succeed();
        succeed.setMsg(managerDownload.getName() + "导出申请已提交,请到【报表中心-下载列表查看】");
        return succeed;
    }

    //学员小课记录导出
    @Override
    public HttpResponseResult exportStudentVipPractice(Map<String, Object> info,List<String> headColumns){
        String organId = getParam(info, "organId", String.class);
        Boolean hasCourse = courseScheduleStudentPaymentDao.hasCourse(organId, TenantContextHolder.getTenantId());
        if (hasCourse == null || !hasCourse) {
            return BaseController.failed("没有可导出的数据");
        }
        Integer tenantId = TenantContextHolder.getTenantId();
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        ManagerDownload managerDownload = saveManagerDownload(ExportTypeEnum.STUDENT_VIP_PRACTICE,sysUser.getId());
        try {
            this.studentVipPractice(organId, managerDownload, tenantId,headColumns);
        } catch (FileNotFoundException e) {
            return BaseController.failed(e.getMessage());
        }
        HttpResponseResult<Object> succeed = BaseController.succeed();
        succeed.setMsg(managerDownload.getName() + "导出申请已提交,请到【报表中心-下载列表查看】");
        return succeed;
    }

    //订单列表导出
    @Override
    public HttpResponseResult orderList(Map<String, Object> info,List<String> headColumns){
        StudentPaymentOrderQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),StudentPaymentOrderQueryInfo.class);
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        if(sysUser == null || sysUser.getId() == null){
            return BaseController.failed(HttpStatus.FORBIDDEN, "请登录");
        }
        queryInfo.setOrganId(organizationService.getEmployeeOrgan(sysUser.getId(),queryInfo.getOrganId(),sysUser.getIsSuperAdmin()));
        if (StringUtils.isNotBlank(queryInfo.getSearch())) {
            List<BasicUserDto> users = studentPaymentOrderDao.getUsers(queryInfo.getSearch());
            List<Integer> userIds = users.stream().map(BasicUserDto::getUserId).collect(Collectors.toList());
            if (userIds.size() <= 0) {
                userIds.add(0);
            }
            queryInfo.setUserIds(userIds);
        }
        Map<String, Object> params = new HashMap<>();
        MapUtil.populateMap(params, queryInfo);
        int count = studentPaymentOrderDao.queryCount(params);
        if (count <= 0) {
            return BaseController.failed("没有可导出的数据");
        }
        if (count > 50000) {
            return BaseController.failed("数据集太大，不能导出.最大数据集不能超过50000");
        }
        ManagerDownload managerDownload = saveManagerDownload(ExportTypeEnum.ORDER,sysUser.getId());
        try {
            this.orderList(params, managerDownload, headColumns);
        } catch (FileNotFoundException e) {
            return BaseController.failed(e.getMessage());
        }
        HttpResponseResult<Object> succeed = BaseController.succeed();
        succeed.setMsg(managerDownload.getName() + "导出申请已提交,请到【报表中心-下载列表查看】");
        return succeed;
    }

    //终课表列表导出
    @Override
    public HttpResponseResult superFindCourseSchedules(Map<String, Object> info){
        EndCourseScheduleQueryInfo queryInfo = JSONObject.parseObject(JSONObject.toJSONString(info),EndCourseScheduleQueryInfo.class);
        SysUser sysUser = sysUserFeignService.queryUserInfo();
        if (sysUser == null) {
            throw new BizException("用户信息获取失败");
        }
        queryInfo.setOrganIdList(organizationService.getEmployeeOrgan(sysUser.getId(),queryInfo.getOrganIdList(),sysUser.getIsSuperAdmin()));
        Map<String, Object> params = new HashMap<>();
        MapUtil.populateMap(params, queryInfo);
        int count = scheduleService.endCountCourseSchedules(params);
        if (count <= 0) {
            return BaseController.failed("没有可导出的数据");
        }
        if (count > 50000) {
            return BaseController.failed("数据集太大，不能导出.最大数据集不能超过50000");
        }
        ManagerDownload managerDownload = saveManagerDownload(ExportTypeEnum.COURSE_SCHEDULE,sysUser.getId());
        try {
            this.superFindCourseSchedules(queryInfo, managerDownload);
        } catch (FileNotFoundException e) {
            return BaseController.failed(e.getMessage());
        }
        HttpResponseResult<Object> succeed = BaseController.succeed();
        succeed.setMsg(managerDownload.getName() + "导出申请已提交,请到【报表中心-下载列表查看】");
        return succeed;
    }

    //保存下载记录
    @Override
    public ManagerDownload saveManagerDownload(ExportTypeEnum exportTypeEnum, Integer userId){
        Date nowDate = new Date();
        String fileName = new StringBuffer(exportTypeEnum.getDesc())
                .append("-")
                .append(idGeneratorService.generatorId("download"))
                .append("-")
                .append(DateUtil.getDate(nowDate))
                .append(".xls").toString();
        ManagerDownload managerDownload = new ManagerDownload();
        managerDownload.setType(ExportTypeEnum.COURSE_SCHEDULE);
        managerDownload.setUserId(userId);
        managerDownload.setName(fileName);
        managerDownload.setFileUrl("");
        managerDownload.setCreateTime(nowDate);
        managerDownload.setUpdateTime(nowDate);
        managerDownloadDao.insert(managerDownload);
        return managerDownload;
    }


    @Override
    @Async
    public void orderList(Map<String, Object> params, ManagerDownload managerDownload,List<String> headColumns) throws FileNotFoundException {
        List<StudentPaymentOrderExportDto> studentPaymentOrderExportDtos = studentPaymentOrderService.ExportQueryPage(params);
        long i = 1;
        Map<Integer, String> cooperationOrganMap = new HashMap<>();
        List<Integer> cooperationOrganIds = studentPaymentOrderExportDtos.stream()
                .filter(e -> OrderTypeEnum.OUTORDER.equals(e.getType()))
                .filter(e -> e.getMusicGroupId() != null)
                .map(e -> Integer.valueOf(e.getMusicGroupId()))
                .distinct()
                .collect(Collectors.toList());
        if (cooperationOrganIds.size() > 0) {
            List<CooperationOrgan> cooperationOrgans = cooperationOrganDao.getCooperationOrganByIds(cooperationOrganIds);
            cooperationOrganMap = cooperationOrgans.stream().collect(Collectors.toMap(CooperationOrgan::getId, CooperationOrgan::getName));
        }
        
        //获取机构费率
        Integer tenantId = (Integer) params.get("tenantId");
        TenantConfig tenantConfig = tenantConfigService.queryByTenantId(tenantId);
        
        for (StudentPaymentOrderExportDto row : studentPaymentOrderExportDtos) {
            if (row.getActualAmount() == null) {
                row.setActualAmount(BigDecimal.ZERO);
            }
            if (row.getBalancePaymentAmount() == null) {
                row.setBalancePaymentAmount(BigDecimal.ZERO);
            }
            if (row.getMemo() == null) {
                row.setMemo("");
            }
            BigDecimal transferFee = BigDecimal.ZERO;
            if (row.getPaymentChannel() != null && row.getPaymentChannel().equals("ADAPAY")) {
                transferFee = row.getActualAmount().multiply(new BigDecimal("0.28")).divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
            }
            row.setTransferFee(transferFee);
            row.setPlatformFee(row.getActualAmount().multiply(tenantConfig.getChargeRate()).divide(new BigDecimal(1000), 2, BigDecimal.ROUND_HALF_UP));

            String goodsName = "";
            if (row.getOrderDetailList() != null) {
                for (StudentPaymentOrderDetail orderDetail : row.getOrderDetailList()) {
                    switch (orderDetail.getType()) {
                        case COURSE:
                        case CLASSROOM:
                        case SINGLE:
                        case MIX:
                        case COMPREHENSIVE:
                        case ENLIGHTENMENT:
                        case TRAINING_SINGLE:
                        case TRAINING_MIX:
                        case MUSIC_NETWORK:
                        case HIGH:
                        case HIGH_ONLINE:
                        case HIGH_ONLINE_COURSE:
                            row.setMusicGroupCourseFee(row.getMusicGroupCourseFee().add(orderDetail.getPrice()));
                            break;
                        case MUSICAL:
                            if (orderDetail.getKitGroupPurchaseType() != null && orderDetail.getKitGroupPurchaseType().equals(KitGroupPurchaseTypeEnum.LEASE)) {
                                BigDecimal leaseFee = BigDecimal.ZERO;
                                if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                    leaseFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                                }
                                row.setLeaseFee(leaseFee);
                            } else {
                                row.setMusicalFee(orderDetail.getPrice());
                            }
                            break;
                        case ACCESSORIES:
                        case TEACHING:
                            row.setTeachingFee(row.getTeachingFee().add(orderDetail.getPrice()));
                            break;
                        case OTHER:
                            row.setOtherFee(row.getOtherFee().add(orderDetail.getPrice()));
                            break;
                        case MAINTENANCE:
                            BigDecimal repairFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                repairFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setMaintenanceFee(repairFee);
                            break;
                        case CLOUD_TEACHER:
                        case CLOUD_TEACHER_PLUS:
                            BigDecimal cloudTeacherFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                cloudTeacherFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setCloudTeacherFee(cloudTeacherFee);
                            break;
                        case DEGREE_REGISTRATION:
                            BigDecimal degreeFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                degreeFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setDegreeFee(degreeFee);
                            break;
                        case VIP:
                            BigDecimal vipCourseFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                vipCourseFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setVipCourseFee(vipCourseFee);
                            break;
                        case THEORY_COURSE:
                            BigDecimal theoryCourseFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                theoryCourseFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setTheoryCourseFee(theoryCourseFee);
                            break;
                        default:
                            break;
                    }
                }
            }
            if (row.getGoodsList() != null) {
                goodsName = row.getGoodsList().stream().map(Goods::getName).collect(Collectors.joining("|"));
            }
            if (StringUtils.isNotBlank(goodsName)) {
                row.setMemo(goodsName);
            }
            //专业
            if (row.getGroupType().equals(GroupType.VIP)) {
                row.setVipCourseFee(row.getActualAmount());
                VipGroup vipGroupInfo = vipGroupDao.findVipGroupInfo(Integer.parseInt(row.getMusicGroupId()), row.getClassGroupId());
                if (vipGroupInfo != null) {
                    row.setSchoolName(vipGroupInfo.getSchoolName());
                    row.setSubjectName(vipGroupInfo.getSubjectName());
                    row.setEduTeacher(vipGroupInfo.getEducationalTeacherName());
                }
            }else if(row.getGroupType() == GroupType.ACTIVITY){
                row.setVipCourseFee(row.getActualAmount());
            }else if(row.getGroupType() == GroupType.MEMBER){
                row.setCloudTeacherFee(row.getActualAmount());
            } else if (row.getGroupType().equals(GroupType.SPORADIC)) {
                //考级报名
                if (row.getType().equals(OrderTypeEnum.DEGREE_REGISTRATION)) {
                    String[] feeTypes = row.getMemo().split("；");
                    List<String> feeTypeList = Arrays.asList(feeTypes);
                    for (String feeTypeStr : feeTypeList) {
                        int index = feeTypeStr.lastIndexOf("：");
                        if (index < 0) {
                            continue;
                        }
                        BigDecimal typeFee = new BigDecimal(feeTypeStr.substring(index + 1));
                        if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                            typeFee = typeFee.multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                        }
                        if (feeTypeStr.contains("VIP")) {
                            row.setVipCourseFee(typeFee);
                        } else if (feeTypeStr.contains("网管课")) {
                            row.setPracticeCourseFee(typeFee);
                        } else if (feeTypeStr.contains("乐理课")) {
                            row.setTheoryCourseFee(typeFee);
                        }
                    }
                    row.setDegreeFee(row.getActualAmount().subtract(row.getVipCourseFee()).subtract(row.getPracticeCourseFee()).subtract(row.getTheoryCourseFee()));
                } else {
                    if (row.getChargeType() != null && SporadicChargeTypeEnum.LEVEL.getCode().equals(row.getChargeType())) {
                        row.setDegreeFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.PRACTICE_GROUP_BUY.getCode().equals(row.getChargeType())) {
                        row.setPracticeCourseFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.MUSIC_UPKEEP.getCode().equals(row.getChargeType())) {
                        row.setMaintenanceFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.VISITING_FEE.getCode().equals(row.getChargeType())) {
                        row.setVisitFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && (SporadicChargeTypeEnum.RECHARGE.getCode().equals(row.getChargeType()) ||
                            SporadicChargeTypeEnum.HIGH_ONLINE_ACTIVITY.getCode().equals(row.getChargeType()))) {
                        row.setRechargeFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.CLOUD_TEACHER_BUY.getCode().equals(row.getChargeType())) {
                        row.setCloudTeacherFee(row.getActualAmount());
                    } else {
                        row.setOtherFee(row.getActualAmount());
                    }
                }
                if (row.getChargeType() != null) {
                    for (SporadicChargeTypeEnum chargeType : SporadicChargeTypeEnum.values()) {
                        if (!chargeType.getCode().equals(row.getChargeType())) continue;
                        row.setSporadicType(chargeType.getMsg());
                    }
                }
            } else if (row.getGroupType().equals(GroupType.PRACTICE)) {
                row.setPracticeCourseFee(row.getActualAmount());
                PracticeCourseDto practiceGroup = practiceGroupDao.findByGroupId(Integer.parseInt(row.getMusicGroupId()));
                if (practiceGroup != null) {
                    row.setSubjectName(practiceGroup.getSubjectName());
                    row.setEduTeacher(practiceGroup.getEduTeacherName());
                }
            } else if (row.getGroupType().equals(GroupType.REPLACEMENT)) {
                row.setMusicalFee(row.getActualAmount());
                ReplacementInstrumentActivityStatDto info = replacementInstrumentActivityDao.getInfo(Integer.parseInt(row.getMusicGroupId()));
                if (info != null) {
                    row.setSubjectName(info.getSubjectName());
                    row.setCooperationOrganName(info.getCooperationOrganName());
                    row.setMemo(info.getBrand() + "(" + info.getSpecification() + ")");
                    CooperationOrgan cooperationOrganEduTeacher = musicGroupDao.findCooperationOrganEduTeacher(info.getCooperationOrganId());
                    if (cooperationOrganEduTeacher != null) {
                        row.setEduTeacher(cooperationOrganEduTeacher.getLinkman());
                    }
                }
            } else {
                StudentPaymentOrderExportDto feeByType = sellOrderDao.getFeeByType(row.getId());
                BigDecimal childRepairFee = sellOrderDao.getChildRepair(row.getId());
                row.setMusicalFee(feeByType.getMusicalFee());
                row.setTeachingFee(feeByType.getTeachingFee().subtract(childRepairFee));
                row.setMaintenanceProductFee(feeByType.getRepairFee().add(childRepairFee));
                row.setOtherFee(feeByType.getOtherFee());
                if (row.getGroupType().equals(GroupType.MUSIC)) {
                    StudentRegistration studentRegistration = studentRegistrationDao.findStudentByMusicGroupIdAndUserId(row.getMusicGroupId(), row.getUserId());
                    if (studentRegistration != null) {
                        row.setSubjectName(studentRegistration.getSubjectName());
                        row.setSchoolName(studentRegistration.getSchoolName());
                        row.setCooperationOrganName(studentRegistration.getRemark());
                        row.setEduTeacher(studentRegistration.getName());
                    }
                    row.setMusicGroupCourseFee(feeByType.getActualAmount().subtract(feeByType.getMusicalFee()).subtract(row.getTeachingFee()).subtract(row.getMaintenanceFee()).subtract(row.getMaintenanceProductFee()).subtract(feeByType.getOtherFee()).subtract(row.getLeaseFee()).subtract(row.getCloudTeacherFee()));
                } else if (row.getType().equals(OrderTypeEnum.REPAIR)) {
                    row.setRepairFee(feeByType.getActualAmount().subtract(feeByType.getMusicalFee()).subtract(feeByType.getTeachingFee()).subtract(feeByType.getOtherFee()));
                } else if (row.getType().equals(OrderTypeEnum.OUTORDER)) {
                    row.setMusicGroupCourseFee(feeByType.getActualAmount().subtract(feeByType.getMusicalFee()).subtract(row.getTeachingFee()).subtract(row.getMaintenanceProductFee()).subtract(feeByType.getOtherFee()));
                    row.setTransferFee(BigDecimal.ZERO);
                    row.setPlatformFee(BigDecimal.ZERO);
                }
            }
            //如果合作单位不存在取学员的第一个乐团的合作单位,乐团主管
            if (row.getCooperationOrganName() == null) {
                CooperationOrgan cooperationOrgan = studentService.getStudentEduTeacher(row.getUserId());
                if (cooperationOrgan != null) {
                    row.setCooperationOrganName(cooperationOrgan.getName());
                    row.setEduTeacher(cooperationOrgan.getLinkman() != null ? cooperationOrgan.getLinkman() : row.getEduTeacher());
                }
            }
            if (row.getType().equals(OrderTypeEnum.OUTORDER) && row.getMusicGroupId() != null) {
                if (cooperationOrganMap.containsKey(Integer.valueOf(row.getMusicGroupId()))) {
                    row.setCooperationOrganName(cooperationOrganMap.get(Integer.valueOf(row.getMusicGroupId())));
                    CooperationOrgan cooperationOrganEduTeacher = musicGroupDao.findCooperationOrganEduTeacher(Integer.valueOf(row.getMusicGroupId()));
                    if (cooperationOrganEduTeacher != null) {
                        row.setEduTeacher(cooperationOrganEduTeacher.getLinkman());
                    }
                }
            }
            if (row.getMusicGroupId() != null && row.getMusicGroupId().equals("null")) {
                row.setMusicGroupId("");
            }
            String paymentChannel = "";
            if (row.getPaymentChannel() == null) {
            } else if (row.getPaymentChannel().equals("YQPAY")) {
                paymentChannel = "双乾";
            } else if (row.getPaymentChannel().equals("ADAPAY")) {
                paymentChannel = "汇付";
            } else if (row.getPaymentChannel().equals("BALANCE")) {
                paymentChannel = "余额";
            }
            row.setPaymentChannel(paymentChannel);
            row.setId(i);
            row.setRepairFee(row.getRepairFee().add(row.getMaintenanceProductFee()));
            row.setOrderAmount(row.getExpectAmount().add(row.getCouponRemitFee()));
            i++;
        }

        String basePath = new ApplicationHome(this.getClass()).getSource().getParentFile().getPath();
        File file = new File(basePath + "/" + managerDownload.getName());
        FileOutputStream fileOutputStream = new FileOutputStream(file);

        HSSFWorkbook workbook = null;
        try {
            Map<String, String> headMap = getExportMap(new ExportDto(ExportEnum.ORDER_LIST1, headColumns));
            String[] header = headMap.keySet().toArray(new String[headMap.keySet().size()]);
            String[] body = headMap.values().toArray(new String[headMap.keySet().size()]);
            /*if(isPlatformUser){
                String[] header = {"序号", "学生编号", "学生姓名", "交易流水号", "订单编号", "收款渠道", "收款账户", "订单金额", "应付金额", "现金支付", "余额支付", "优惠金额",
                        "乐团课", "VIP课", "网管课", "乐理课", "考级", "维修费用", "乐保费用", "团练宝", "押金", "乐器", "教辅费用", "上门费",
                        "账户充值", "其它", "汇付手续费","平台手续费", "到账时间",
                        "关联乐团ID/VIP课ID", "课程形态", "零星收款类别", "专业", "分部", "教学点", "合作单位", "乐团主管", "备注"};
                
                String[] body = {"id", "userId", "user.username", "transNo", "orderNo", "paymentChannel", "merNos", "orderAmount", "expectAmount", "actualAmount", "balancePaymentAmount",  "couponRemitFee",
                        "musicGroupCourseFee", "vipCourseFee", "practiceCourseFee", "theoryCourseFee", "degreeFee", "repairFee", "maintenanceFee", "cloudTeacherFee",
                        "leaseFee", "musicalFee", "teachingFee", "visitFee", "rechargeFee", "otherFee", "transferFee", "platformFee", "payTime", "musicGroupId",
                        "groupType.desc", "sporadicType", "subjectName", "organName", "schoolName", "cooperationOrganName", "eduTeacher", "memo"};
                workbook = POIUtil.exportExcel(header, body, studentPaymentOrderExportDtos);
            }else{
                String[] header = {"序号", "学生编号", "学生姓名", "交易流水号", "订单编号", "收款渠道", "收款账户", "订单金额", "应付金额", "现金支付", "余额支付", "优惠金额",
                        "乐团课", "VIP课", "网管课", "乐理课", "考级", "维修费用", "乐保费用", "团练宝", "押金", "乐器", "教辅费用", "上门费",
                        "账户充值", "其它","平台手续费", "到账时间",
                        "关联乐团ID/VIP课ID", "课程形态", "零星收款类别", "专业", "分部", "教学点", "合作单位", "乐团主管", "备注"};
                
                String[] body = {"id", "userId", "user.username", "transNo", "orderNo", "paymentChannel", "merNos", "orderAmount", "expectAmount", "actualAmount", "balancePaymentAmount",  "couponRemitFee",
                        "musicGroupCourseFee", "vipCourseFee", "practiceCourseFee", "theoryCourseFee", "degreeFee", "repairFee", "maintenanceFee", "cloudTeacherFee",
                        "leaseFee", "musicalFee", "teachingFee", "visitFee", "rechargeFee", "otherFee", "platformFee", "payTime", "musicGroupId",
                        "groupType.desc", "sporadicType", "subjectName", "organName", "schoolName", "cooperationOrganName", "eduTeacher", "memo"};
                workbook = POIUtil.exportExcel(header, body, studentPaymentOrderExportDtos);
            }*/

            workbook = POIUtil.exportExcel(header, body, studentPaymentOrderExportDtos);
            workbook.write(fileOutputStream);
            fileOutputStream.getFD().sync();
            fileOutputStream.close();

            String folder = "download/" + UploadUtil.getFileFloder();
            String url = storagePluginContext.uploadFile(KS3StoragePlugin.PLUGIN_NAME, folder, file);
            //把记录插入下载表
            managerDownload.setFileUrl(url);
            managerDownload.setStatus(1);
            managerDownloadDao.update(managerDownload);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                fileOutputStream.close();
                workbook.close();
                file.delete();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    @Async
    public void routeOrderList(Map<String, Object> params, ManagerDownload managerDownload,List<String> headColumns) throws FileNotFoundException {
        List<StudentPaymentOrderExportDto> studentPaymentOrderExportDtos = studentPaymentRouteOrderDao.ExportQueryPage(params);

        Map<Integer, String> cooperationOrganMap = new HashMap<>();
        List<Integer> cooperationOrganIds = studentPaymentOrderExportDtos.stream()
                .filter(e -> OrderTypeEnum.OUTORDER.equals(e.getType()))
                .filter(e -> e.getMusicGroupId() != null)
                .map(e -> Integer.valueOf(e.getMusicGroupId()))
                .distinct()
                .collect(Collectors.toList());
        if (cooperationOrganIds.size() > 0) {
            List<CooperationOrgan> cooperationOrgans = cooperationOrganDao.getCooperationOrganByIds(cooperationOrganIds);
            cooperationOrganMap = cooperationOrgans.stream().collect(Collectors.toMap(CooperationOrgan::getId, CooperationOrgan::getName));
        }
        
        //获取机构费率
        Integer tenantId = (Integer) params.get("tenantId");
        TenantConfig tenantConfig = tenantConfigService.queryByTenantId(tenantId);
        
        Map<String,BigDecimal> serviceChargeMap = new HashMap<String, BigDecimal>();
        Map<String,Integer> orderCountMap = new HashMap<String, Integer>();
        
        for (StudentPaymentOrderExportDto row : studentPaymentOrderExportDtos) {
            if (row.getActualAmount() == null) {
                row.setActualAmount(BigDecimal.ZERO);
            }
            if (row.getBalancePaymentAmount() == null) {
                row.setBalancePaymentAmount(BigDecimal.ZERO);
            }
            if (row.getRouteAmount() == null) {
                row.setRouteAmount(BigDecimal.ZERO);
            }
            if (row.getMemo() == null) {
                row.setMemo("");
            }
            BigDecimal transferFee = BigDecimal.ZERO;
            BigDecimal currentFee = BigDecimal.ZERO;
            BigDecimal totalFee = BigDecimal.ZERO;
            if (row.getPaymentChannel() != null && row.getPaymentChannel().equals("ADAPAY")) {
                FeeFlagNumDto countFeeFlagNum = studentPaymentRouteOrderDao.getCountFeeFlagNum(row.getOrderNo());
                
                Integer times = orderCountMap.get(row.getOrderNo());
				if (times == null) {
					times = 1;
				} else {
					++times;
				}
            	orderCountMap.put(row.getOrderNo(), times);
            	
            	currentFee = row.getServiceFee();
                
				if (currentFee == null || currentFee.floatValue() == 0) {
					transferFee = serviceChargeMap.get(row.getOrderNo());
					if (transferFee == null) {
						transferFee = BigDecimal.ZERO;
					}

					currentFee = row.getRouteAmount().multiply(new BigDecimal("0.28")).divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
					totalFee = row.getActualAmount().multiply(new BigDecimal("0.28")).divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
					if (totalFee.subtract(transferFee.add(currentFee)).doubleValue() < 0 || times == countFeeFlagNum.getTotalNum()) {
						currentFee = totalFee.subtract(transferFee);
						serviceChargeMap.put(row.getOrderNo(), totalFee);
					} else {
						serviceChargeMap.put(row.getOrderNo(), transferFee.add(currentFee));
					}
				}
                
                /*if (countFeeFlagNum.getTotalNum() > countFeeFlagNum.getYesNum() && row.getFeeFlag().equals("Y")) {
                    transferFee = row.getActualAmount().multiply(new BigDecimal("0.28")).divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
                }
                if (countFeeFlagNum.getTotalNum().equals(countFeeFlagNum.getYesNum())) {
                    BigDecimal totalTransferFee = row.getActualAmount().multiply(new BigDecimal("0.28")).divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
                    transferFee = totalTransferFee.multiply(row.getRouteAmount()).divide(row.getActualAmount(), 2, BigDecimal.ROUND_HALF_UP);
                }*/
                
            }
            row.setTransferFee(currentFee);
            row.setPlatformFee(row.getActualAmount().multiply(tenantConfig.getChargeRate()).divide(new BigDecimal(1000), 2, BigDecimal.ROUND_HALF_UP));

            String goodsName = "";
            if (row.getOrderDetailList() != null) {
                for (StudentPaymentOrderDetail orderDetail : row.getOrderDetailList()) {
                    switch (orderDetail.getType()) {
                        case COURSE:
                        case CLASSROOM:
                        case SINGLE:
                        case MIX:
                        case COMPREHENSIVE:
                        case ENLIGHTENMENT:
                        case TRAINING_SINGLE:
                        case TRAINING_MIX:
                        case MUSIC_NETWORK:
                        case HIGH:
                        case HIGH_ONLINE:
                        case HIGH_ONLINE_COURSE:
                            row.setMusicGroupCourseFee(row.getMusicGroupCourseFee().add(orderDetail.getPrice()));
                            break;
                        case MUSICAL:
                            if (orderDetail.getKitGroupPurchaseType() != null && orderDetail.getKitGroupPurchaseType().equals(KitGroupPurchaseTypeEnum.LEASE)) {
                                BigDecimal leaseFee = orderDetail.getPrice();
                                if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                    leaseFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                                }
                                row.setLeaseFee(leaseFee);
                            } else {
                                row.setMusicalFee(orderDetail.getPrice());
                            }
                            break;
                        case ACCESSORIES:
                        case TEACHING:
                            row.setTeachingFee(row.getTeachingFee().add(orderDetail.getPrice()));
                            break;
                        case OTHER:
                            row.setOtherFee(row.getOtherFee().add(orderDetail.getPrice()));
                            break;
                        case MAINTENANCE:
                            BigDecimal maintenanceFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                maintenanceFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setMaintenanceFee(maintenanceFee);
                            break;
                        case CLOUD_TEACHER:
                        case CLOUD_TEACHER_PLUS:
                            BigDecimal cloudTeacherFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                cloudTeacherFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setCloudTeacherFee(cloudTeacherFee);
                            break;
                        case DEGREE_REGISTRATION:
                            BigDecimal degreeFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                degreeFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setDegreeFee(degreeFee);
                            break;
                        case VIP:
                            BigDecimal vipCourseFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                vipCourseFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setVipCourseFee(vipCourseFee);
                            break;
                        case THEORY_COURSE:
                            BigDecimal theoryCourseFee = BigDecimal.ZERO;
                            if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                                theoryCourseFee = orderDetail.getPrice().multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                            }
                            row.setTheoryCourseFee(theoryCourseFee);
                            break;
                        default:
                            break;
                    }
                }
            }
            if (row.getGoodsList() != null) {
                goodsName = row.getGoodsList().stream().map(Goods::getName).collect(Collectors.joining("|"));
            }
            if (StringUtils.isNotBlank(goodsName)) {
                row.setMemo(goodsName);
            }
            //专业
            if (row.getGroupType().equals(GroupType.VIP)) {
                row.setVipCourseFee(row.getActualAmount());
                VipGroup vipGroupInfo = vipGroupDao.findVipGroupInfo(Integer.parseInt(row.getMusicGroupId()), row.getClassGroupId());
                if (vipGroupInfo != null) {
                    row.setSchoolName(vipGroupInfo.getSchoolName());
                    row.setSubjectName(vipGroupInfo.getSubjectName());
                    row.setEduTeacher(vipGroupInfo.getEducationalTeacherName());
                }
            } else if(row.getGroupType().equals(GroupType.ACTIVITY)){
                row.setVipCourseFee(row.getActualAmount());
            }else if (row.getGroupType().equals(GroupType.SPORADIC)) {
                //考级报名
                if (row.getType().equals(OrderTypeEnum.DEGREE_REGISTRATION)) {
                    String[] feeTypes = row.getMemo().split("；");
                    List<String> feeTypeList = Arrays.asList(feeTypes);
                    for (String feeTypeStr : feeTypeList) {
                        int index = feeTypeStr.lastIndexOf("：");
                        if (index < 0) {
                            continue;
                        }
                        BigDecimal typeFee = new BigDecimal(feeTypeStr.substring(index + 1));
                        if (row.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                            typeFee = typeFee.multiply(row.getActualAmount()).divide(row.getExpectAmount(), 2, BigDecimal.ROUND_DOWN);
                        }
                        if (feeTypeStr.contains("VIP")) {
                            row.setVipCourseFee(typeFee);
                        } else if (feeTypeStr.contains("网管课")) {
                            row.setPracticeCourseFee(typeFee);
                        } else if (feeTypeStr.contains("乐理课")) {
                            row.setTheoryCourseFee(typeFee);
                        }
                    }
                    row.setDegreeFee(row.getActualAmount().subtract(row.getVipCourseFee()).subtract(row.getPracticeCourseFee()).subtract(row.getTheoryCourseFee()));
                } else {
                    if (row.getChargeType() != null && SporadicChargeTypeEnum.LEVEL.getCode().equals(row.getChargeType())) {
                        row.setDegreeFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.PRACTICE_GROUP_BUY.getCode().equals(row.getChargeType())) {
                        row.setPracticeCourseFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.MUSIC_UPKEEP.getCode().equals(row.getChargeType())) {
                        row.setMaintenanceFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.VISITING_FEE.getCode().equals(row.getChargeType())) {
                        row.setVisitFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && (SporadicChargeTypeEnum.RECHARGE.getCode().equals(row.getChargeType()) ||
                            SporadicChargeTypeEnum.HIGH_ONLINE_ACTIVITY.getCode().equals(row.getChargeType()))) {
                        row.setRechargeFee(row.getActualAmount());
                    } else if (row.getChargeType() != null && SporadicChargeTypeEnum.CLOUD_TEACHER_BUY.getCode().equals(row.getChargeType())) {
                        row.setCloudTeacherFee(row.getActualAmount());
                    } else {
                        row.setOtherFee(row.getActualAmount());
                    }
                }
                if (row.getChargeType() != null) {
                    for (SporadicChargeTypeEnum chargeType : SporadicChargeTypeEnum.values()) {
                        if (!chargeType.getCode().equals(row.getChargeType())) continue;
                        row.setSporadicType(chargeType.getMsg());
                    }
                }
            } else if (row.getGroupType().equals(GroupType.PRACTICE)) {
                row.setPracticeCourseFee(row.getActualAmount());
                PracticeCourseDto practiceGroup = practiceGroupDao.findByGroupId(Integer.parseInt(row.getMusicGroupId()));
                if (practiceGroup != null) {
                    row.setSubjectName(practiceGroup.getSubjectName());
                    row.setEduTeacher(practiceGroup.getEduTeacherName());
                }
            } else if (row.getGroupType().equals(GroupType.MEMBER)) {
                row.setCloudTeacherFee(row.getActualAmount());
            } else if (row.getGroupType().equals(GroupType.REPLACEMENT)) {
                row.setMusicalFee(row.getActualAmount());
                ReplacementInstrumentActivityStatDto info = replacementInstrumentActivityDao.getInfo(Integer.parseInt(row.getMusicGroupId()));
                if (info != null) {
                    row.setSubjectName(info.getSubjectName());
                    row.setCooperationOrganName(info.getCooperationOrganName());
                    row.setMemo(info.getBrand() + "(" + info.getSpecification() + ")");
                    CooperationOrgan cooperationOrganEduTeacher = musicGroupDao.findCooperationOrganEduTeacher(info.getCooperationOrganId());
                    if (cooperationOrganEduTeacher != null) {
                        row.setEduTeacher(cooperationOrganEduTeacher.getLinkman());
                    }
                }
            } else {
                StudentPaymentOrderExportDto feeByType = sellOrderDao.getFeeByType(row.getId());
                BigDecimal childRepairFee = sellOrderDao.getChildRepair(row.getId());
                row.setMusicalFee(feeByType.getMusicalFee());
                row.setTeachingFee(feeByType.getTeachingFee().subtract(childRepairFee));
                row.setMaintenanceProductFee(feeByType.getRepairFee().add(childRepairFee));
                row.setOtherFee(feeByType.getOtherFee());
                if (row.getGroupType().equals(GroupType.MUSIC)) {
                    StudentRegistration studentRegistration = studentRegistrationDao.findStudentByMusicGroupIdAndUserId(row.getMusicGroupId(), row.getUserId());
                    if (studentRegistration != null) {
                        row.setSubjectName(studentRegistration.getSubjectName());
                        row.setSchoolName(studentRegistration.getSchoolName());
                        row.setCooperationOrganName(studentRegistration.getRemark());
                        row.setEduTeacher(studentRegistration.getName());
                    }
                    row.setMusicGroupCourseFee(feeByType.getActualAmount().subtract(feeByType.getMusicalFee()).subtract(row.getTeachingFee()).subtract(row.getMaintenanceFee()).subtract(row.getMaintenanceProductFee()).subtract(feeByType.getOtherFee()).subtract(row.getLeaseFee()).subtract(row.getCloudTeacherFee()));
                } else if (row.getType().equals(OrderTypeEnum.REPAIR)) {
                    row.setRepairFee(feeByType.getActualAmount().subtract(feeByType.getMusicalFee()).subtract(feeByType.getTeachingFee()).subtract(feeByType.getOtherFee()));
                } else if (row.getType().equals(OrderTypeEnum.OUTORDER)) {
                    row.setMusicGroupCourseFee(feeByType.getActualAmount().subtract(feeByType.getMusicalFee()).subtract(feeByType.getTeachingFee()).subtract(feeByType.getRepairFee()).subtract(feeByType.getOtherFee()));
                    row.setTransferFee(BigDecimal.ZERO);
                    row.setPlatformFee(BigDecimal.ZERO);
                }
            }
            //如果合作单位不存在取学员的第一个乐团的合作单位和教学点
            if (row.getCooperationOrganName() == null) {
                CooperationOrgan cooperationOrgan = studentService.getStudentEduTeacher(row.getUserId());
                if (cooperationOrgan != null) {
                    row.setCooperationOrganName(cooperationOrgan.getName());
                    row.setEduTeacher(cooperationOrgan.getLinkman() != null ? cooperationOrgan.getLinkman() : row.getEduTeacher());
                }
            }
            if (row.getType().equals(OrderTypeEnum.OUTORDER) && row.getMusicGroupId() != null) {
                if (cooperationOrganMap.containsKey(Integer.valueOf(row.getMusicGroupId()))) {
                    row.setCooperationOrganName(cooperationOrganMap.get(Integer.valueOf(row.getMusicGroupId())));
                    CooperationOrgan cooperationOrganEduTeacher = musicGroupDao.findCooperationOrganEduTeacher(Integer.valueOf(row.getMusicGroupId()));
                    if (cooperationOrganEduTeacher != null) {
                        row.setEduTeacher(cooperationOrganEduTeacher.getLinkman());
                    }
                }
            }
            if (row.getMusicGroupId() != null && row.getMusicGroupId().equals("null")) {
                row.setMusicGroupId("");
            }
            String paymentChannel = "";
            if (row.getPaymentChannel() == null) {
            } else if (row.getPaymentChannel().equals("YQPAY")) {
                paymentChannel = "双乾";
            } else if (row.getPaymentChannel().equals("ADAPAY")) {
                paymentChannel = "汇付";
            } else if (row.getPaymentChannel().equals("BALANCE")) {
                paymentChannel = "余额";
            }
            row.setPaymentChannel(paymentChannel);
            row.setOrderAmount(row.getExpectAmount().add(row.getCouponRemitFee()));
        }

        Map<Long, List<StudentPaymentOrderExportDto>> orderMap = studentPaymentOrderExportDtos.stream().collect(Collectors.groupingBy(StudentPaymentOrderExportDto::getId));
        orderMap.forEach((orderId, orders) -> {
            int j = 1;
            BigDecimal routeMusicGroupCourseFee = BigDecimal.ZERO;
            BigDecimal routeVipCourseFee = BigDecimal.ZERO;
            BigDecimal routePracticeCourseFee = BigDecimal.ZERO;
            BigDecimal routeTheoryCourseFee = BigDecimal.ZERO;
            BigDecimal routeDegreeFee = BigDecimal.ZERO;
            BigDecimal routeRepairFee = BigDecimal.ZERO;
            BigDecimal routeMaintenanceFee = BigDecimal.ZERO;
            BigDecimal routeMaintenanceProductFee = BigDecimal.ZERO;
            BigDecimal routeLeaseFee = BigDecimal.ZERO;
            BigDecimal routeMusicalFee = BigDecimal.ZERO;
            BigDecimal routeTeachingFee = BigDecimal.ZERO;
            BigDecimal routeOtherFee = BigDecimal.ZERO;
            BigDecimal routeCloudTeacherFee = BigDecimal.ZERO;
            BigDecimal routeRechargeFee = BigDecimal.ZERO;
            for (StudentPaymentOrderExportDto order : orders) {
                Date endDate = DateUtil.stringToDate("2021-04-01", "yyyy-MM-dd");
                if (order.getPayTime() == null || order.getPayTime().compareTo(endDate) < 0) {
                    break;
                }
                if (order.getSaleAmount().compareTo(BigDecimal.ZERO) > 0 && order.getServiceAmount().compareTo(BigDecimal.ZERO) == 0) {
                    order.setMusicGroupCourseFee(BigDecimal.ZERO);
                    order.setVipCourseFee(BigDecimal.ZERO);
                    order.setPracticeCourseFee(BigDecimal.ZERO);
                    order.setTheoryCourseFee(BigDecimal.ZERO);
                    order.setDegreeFee(BigDecimal.ZERO);
                    order.setMaintenanceFee(BigDecimal.ZERO);
                    order.setCloudTeacherFee(BigDecimal.ZERO);
                    order.setRepairFee(order.getMaintenanceProductFee());
                    continue;
                } else if (order.getSaleAmount().compareTo(BigDecimal.ZERO) == 0 && order.getServiceAmount().compareTo(BigDecimal.ZERO) > 0) {
                    order.setRepairFee(order.getRepairFee());
                    order.setCloudTeacherFee(order.getCloudTeacherFee());
                    order.setMaintenanceFee(order.getMaintenanceFee());
                    order.setMusicalFee(BigDecimal.ZERO);
                    order.setTeachingFee(BigDecimal.ZERO);
                    order.setOtherFee(BigDecimal.ZERO);
                    order.setLeaseFee(BigDecimal.ZERO);
                    continue;
                }
                BigDecimal musicGroupCourseFee = BigDecimal.ZERO;
                BigDecimal vipCourseFee = BigDecimal.ZERO;
                BigDecimal practiceCourseFee = BigDecimal.ZERO;
                BigDecimal theoryCourseFee = BigDecimal.ZERO;
                BigDecimal degreeFee = BigDecimal.ZERO;
                BigDecimal repairFee = BigDecimal.ZERO;
                BigDecimal maintenanceFee = BigDecimal.ZERO;
                BigDecimal maintenanceProductFee = BigDecimal.ZERO;
                BigDecimal leaseFee = BigDecimal.ZERO;
                BigDecimal musicalFee = BigDecimal.ZERO;
                BigDecimal teachingFee = BigDecimal.ZERO;
                BigDecimal otherFee = BigDecimal.ZERO;
                BigDecimal cloudTeacherFee = BigDecimal.ZERO;
                BigDecimal rechargeFee = BigDecimal.ZERO;

                if (order.getActualAmount() != null && order.getActualAmount().compareTo(BigDecimal.ZERO) > 0) {
                    musicGroupCourseFee = order.getMusicGroupCourseFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    vipCourseFee = order.getVipCourseFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    practiceCourseFee = order.getPracticeCourseFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    theoryCourseFee = order.getTheoryCourseFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    degreeFee = order.getDegreeFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    repairFee = order.getRepairFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    maintenanceProductFee = order.getMaintenanceProductFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    leaseFee = order.getLeaseFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    musicalFee = order.getMusicalFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    teachingFee = order.getTeachingFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    otherFee = order.getOtherFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    maintenanceFee = order.getMaintenanceFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                    cloudTeacherFee = order.getCloudTeacherFee().multiply(order.getRouteAmount()).divide(order.getActualAmount(), 2, BigDecimal.ROUND_DOWN);
                }

                if (order.getGroupType().equals(GroupType.VIP)) {
                    vipCourseFee = order.getRouteAmount();
                } else if (order.getGroupType().equals(GroupType.SPORADIC)) {
                    //考级报名
                    if (order.getType().equals(OrderTypeEnum.DEGREE_REGISTRATION)) {
                        degreeFee = order.getRouteAmount().subtract(vipCourseFee).subtract(practiceCourseFee).subtract(theoryCourseFee);
                    } else {
                        if (order.getChargeType() != null && SporadicChargeTypeEnum.LEVEL.getCode().equals(order.getChargeType())) {
                            degreeFee = order.getRouteAmount();
                        } else if (order.getChargeType() != null && SporadicChargeTypeEnum.PRACTICE_GROUP_BUY.getCode().equals(order.getChargeType())) {
                            practiceCourseFee = order.getRouteAmount();
                        } else if (order.getChargeType() != null && SporadicChargeTypeEnum.RECHARGE.getCode().equals(order.getChargeType())) {
                            rechargeFee = order.getRouteAmount();
                        } else {
                            otherFee = order.getRouteAmount();
                        }
                    }
                } else if (order.getGroupType().equals(GroupType.PRACTICE)) {
                    practiceCourseFee = order.getRouteAmount();
                } else {
                    if (order.getGroupType().equals(GroupType.MUSIC)) {
                        musicGroupCourseFee = order.getRouteAmount().subtract(musicalFee).subtract(teachingFee).subtract(maintenanceFee).subtract(maintenanceProductFee).subtract(otherFee).subtract(leaseFee).subtract(cloudTeacherFee);
                    } else if (order.getType().equals(OrderTypeEnum.REPAIR)) {
                        repairFee = order.getRouteAmount().subtract(musicalFee).subtract(teachingFee).subtract(otherFee);
                    } else if (order.getType().equals(OrderTypeEnum.OUTORDER)) {
                        musicGroupCourseFee = order.getRouteAmount().subtract(musicalFee).subtract(teachingFee).subtract(maintenanceProductFee).subtract(otherFee);
                    }
                }

                if (j == orders.size()) {
                    musicGroupCourseFee = order.getMusicGroupCourseFee().subtract(routeMusicGroupCourseFee);
                    vipCourseFee = order.getVipCourseFee().subtract(routeVipCourseFee);
                    practiceCourseFee = order.getPracticeCourseFee().subtract(routePracticeCourseFee);
                    theoryCourseFee = order.getTheoryCourseFee().subtract(routeTheoryCourseFee);
                    degreeFee = order.getDegreeFee().subtract(routeDegreeFee);
                    repairFee = order.getRepairFee().subtract(routeRepairFee);
                    maintenanceProductFee = order.getMaintenanceProductFee().subtract(routeMaintenanceProductFee);
                    leaseFee = order.getLeaseFee().subtract(routeLeaseFee);
                    musicalFee = order.getMusicalFee().subtract(routeMusicalFee);
                    teachingFee = order.getTeachingFee().subtract(routeTeachingFee);
                    otherFee = order.getOtherFee().subtract(routeOtherFee);
                    rechargeFee = order.getRechargeFee().subtract(routeRechargeFee);
                    maintenanceFee = order.getMaintenanceFee().subtract(routeMaintenanceFee);
                    cloudTeacherFee = order.getCloudTeacherFee().subtract(routeCloudTeacherFee);
                }
                j++;

                routeMusicGroupCourseFee = routeMusicGroupCourseFee.add(musicGroupCourseFee);
                routeVipCourseFee = routeVipCourseFee.add(vipCourseFee);
                routePracticeCourseFee = routePracticeCourseFee.add(practiceCourseFee);
                routeTheoryCourseFee = routeTheoryCourseFee.add(theoryCourseFee);
                routeDegreeFee = routeDegreeFee.add(degreeFee);
                routeRepairFee = routeRepairFee.add(repairFee);
                routeMaintenanceProductFee = routeMaintenanceProductFee.add(maintenanceProductFee);
                routeLeaseFee = routeLeaseFee.add(leaseFee);
                routeMusicalFee = routeMusicalFee.add(musicalFee);
                routeTeachingFee = routeTeachingFee.add(teachingFee);
                routeOtherFee = routeOtherFee.add(otherFee);
                routeRechargeFee = routeRechargeFee.add(rechargeFee);
                routeMaintenanceFee = routeMaintenanceFee.add(maintenanceFee);
                routeCloudTeacherFee = routeCloudTeacherFee.add(cloudTeacherFee);

                order.setMusicGroupCourseFee(musicGroupCourseFee);
                order.setVipCourseFee(vipCourseFee);
                order.setPracticeCourseFee(practiceCourseFee);
                order.setTheoryCourseFee(theoryCourseFee);
                order.setDegreeFee(degreeFee);
                order.setRepairFee(repairFee.add(maintenanceProductFee));
                order.setMaintenanceProductFee(maintenanceProductFee);
                order.setLeaseFee(leaseFee);
                order.setMusicalFee(musicalFee);
                order.setTeachingFee(teachingFee);
                order.setOtherFee(otherFee);
                order.setRechargeFee(rechargeFee);
                order.setMaintenanceFee(maintenanceFee);
                order.setCloudTeacherFee(cloudTeacherFee);
            }
        });
        if(params.get("oldOrganId") != null){
            String[] organIdArr = params.get("oldOrganId").toString().split(",");
            List<String> organIds = Arrays.asList(organIdArr);
            studentPaymentOrderExportDtos.removeIf(order -> !organIds.contains(order.getOrganId().toString()));
        }

        String basePath = new ApplicationHome(this.getClass()).getSource().getParentFile().getPath();
        File file = new File(basePath + "/" + managerDownload.getName());
        FileOutputStream fileOutputStream = new FileOutputStream(file);

        HSSFWorkbook workbook = null;
        try {
        	/*if(isPlatformUser){
                String[] header = {"序号", "学生编号", "学生姓名", "交易流水号", "订单编号", "收款渠道", "收款账户", "订单金额", "应付金额",
                        "现金支付", "余额支付", "分润账户", "分润金额", "分配余额", "优惠金额", "乐团课", "VIP课", "网管课", "乐理课",
                        "考级", "维修费用", "乐保费用", "团练宝", "押金", "乐器", "教辅费用", "上门费", "账户充值", "其它", "汇付手续费", "平台手续费", "到账时间",
                        "关联乐团ID/VIP课ID", "课程形态", "零星收款类别", "专业", "分部", "教学点", "合作单位", "乐团主管", "备注"};
                String[] body = {"id", "userId", "user.username", "transNo", "orderNo", "paymentChannel", "merNos", "orderAmount"
                        , "expectAmount", "actualAmount", "balancePaymentAmount", "routeMerNo", "routeAmount", "routeBalance",  "couponRemitFee",
                        "musicGroupCourseFee", "vipCourseFee", "practiceCourseFee", "theoryCourseFee", "degreeFee", "repairFee", "maintenanceFee", "cloudTeacherFee", "leaseFee", "musicalFee", "teachingFee", "visitFee",
                        "rechargeFee", "otherFee", "transferFee", "platformFee", "payTime", "musicGroupId",
                        "groupType.desc", "sporadicType", "subjectName", "organName", "schoolName", "cooperationOrganName", "eduTeacher", "memo"};
                workbook = POIUtil.exportExcel(header, body, studentPaymentOrderExportDtos);
        	}else{
                String[] header = {"序号", "学生编号", "学生姓名", "交易流水号", "订单编号", "收款渠道", "收款账户", "订单金额", "应付金额",
                        "现金支付", "余额支付", "分润账户", "分润金额", "分配余额", "优惠金额", "乐团课", "VIP课", "网管课", "乐理课",
                        "考级", "维修费用", "乐保费用", "团练宝", "押金", "乐器", "教辅费用", "上门费", "账户充值", "其它", "平台手续费", "到账时间",
                        "关联乐团ID/VIP课ID", "课程形态", "零星收款类别", "专业", "分部", "教学点", "合作单位", "乐团主管", "备注"};
                String[] body = {"id", "userId", "user.username", "transNo", "orderNo", "paymentChannel", "merNos", "orderAmount"
                        , "expectAmount", "actualAmount", "balancePaymentAmount", "routeMerNo", "routeAmount", "routeBalance",  "couponRemitFee",
                        "musicGroupCourseFee", "vipCourseFee", "practiceCourseFee", "theoryCourseFee", "degreeFee", "repairFee", "maintenanceFee", "cloudTeacherFee", "leaseFee", "musicalFee", "teachingFee", "visitFee",
                        "rechargeFee", "otherFee", "platformFee", "payTime", "musicGroupId",
                        "groupType.desc", "sporadicType", "subjectName", "organName", "schoolName", "cooperationOrganName", "eduTeacher", "memo"};
                workbook = POIUtil.exportExcel(header, body, studentPaymentOrderExportDtos);
        	}*/
            Map<String, String> headMap = getExportMap(new ExportDto(ExportEnum.ROUTE_ORDER_LIST1, headColumns));
            String[] header = headMap.keySet().toArray(new String[headMap.keySet().size()]);
            String[] body = headMap.values().toArray(new String[headMap.keySet().size()]);
            workbook = POIUtil.exportExcel(header, body, studentPaymentOrderExportDtos);
            workbook.write(fileOutputStream);
            fileOutputStream.getFD().sync();
            fileOutputStream.close();

            String folder = "download/" + UploadUtil.getFileFloder();
            String url = storagePluginContext.uploadFile(KS3StoragePlugin.PLUGIN_NAME, folder, file);
            //把记录插入下载表
            managerDownload.setFileUrl(url);
            managerDownload.setStatus(1);
            managerDownloadDao.update(managerDownload);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                fileOutputStream.close();
                workbook.close();
                file.delete();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    @Async
    public void superFindCourseSchedules(EndCourseScheduleQueryInfo queryInfo, ManagerDownload managerDownload) throws FileNotFoundException {
        List<CourseScheduleEndDto> rows = courseScheduleService.endFindCourseSchedules(queryInfo).getRows();
        for (CourseScheduleEndDto row : rows) {
            row.setIsComplaints(StringUtils.equals(row.getIsComplaints(), "1") ? "有" : "无");
        }
        String basePath = new ApplicationHome(this.getClass()).getSource().getParentFile().getPath();
        File file = new File(basePath + "/" + managerDownload.getName());
        FileOutputStream fileOutputStream = new FileOutputStream(file);
        OutputStream ouputStream = null;
        try {
            HSSFWorkbook workbook = POIUtil.exportExcel(new String[]{"分部名称", "乐团主管", "课程编号", "开始时间", "结束时间",
                    "班级名称", "班级声部", "课程名称", "课程类型", "教学模式",
                    "教学点", "课程状态", "指导老师", "学员编号", "是否点名", "是否有考勤申诉", "预计上课人数"}, new String[]{
                    "organName", "educationTeacherName", "id", "startClassTime", "endClassTime", "classGroupName", "subjectName", "name",
                    "groupType.desc", "teachMode.msg", "schoolName", "status.msg", "teacherName", "studentId", "isCallNames.msg", "isComplaints", "studentNum"}, rows);

            workbook.write(fileOutputStream);
            fileOutputStream.getFD().sync();
            fileOutputStream.close();

            String folder = "download/" + UploadUtil.getFileFloder();
            String url = storagePluginContext.uploadFile(KS3StoragePlugin.PLUGIN_NAME, folder, file);
            //把记录插入下载表
            managerDownload.setFileUrl(url);
            managerDownload.setStatus(1);
            managerDownloadDao.update(managerDownload);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (ouputStream != null) {
                try {
                    ouputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    @Override
    @Async
    public void studentVipPractice(String organId, ManagerDownload managerDownload, Integer tenantId,List<String> headColumns) throws FileNotFoundException {
        List<StudentVipPracticeExportDto> studentVipPracticeExportDtos = courseScheduleStudentPaymentDao.exportStudentVipPractice(organId, tenantId);
        if(studentVipPracticeExportDtos != null && studentVipPracticeExportDtos.size() > 0){
            List<Integer> studentIds = studentVipPracticeExportDtos.stream().map(e -> e.getUserId()).collect(Collectors.toList());
            //获取学员最后一节已结束的vip课的老师以及编号
            List<BaseNameDto> vipBaseNameDtos = courseScheduleStudentPaymentDao.queryLastOverTeacher(studentIds,"VIP");
            Map<Integer, List<BaseNameDto>> vipBaseNameMap = new HashMap<>();
            if(vipBaseNameDtos != null && vipBaseNameDtos.size() > 0){
                vipBaseNameMap = vipBaseNameDtos.stream().collect(Collectors.groupingBy(BaseNameDto::getUserId));
            }
            //获取学员最后一节已结束的网管课的老师以及编号
            List<BaseNameDto> practiceBaseNameDtos = courseScheduleStudentPaymentDao.queryLastOverTeacher(studentIds,"PRACTICE");
            Map<Integer, List<BaseNameDto>> practiceBaseNameMap = new HashMap<>();
            if(practiceBaseNameDtos != null && practiceBaseNameDtos.size() > 0){
                practiceBaseNameMap = practiceBaseNameDtos.stream().collect(Collectors.groupingBy(BaseNameDto::getUserId));
            }
            for (StudentVipPracticeExportDto studentVipPracticeExportDto : studentVipPracticeExportDtos) {
                List<BaseNameDto> baseNameDtos = vipBaseNameMap.get(studentVipPracticeExportDto.getUserId());
                if(baseNameDtos != null && baseNameDtos.size() > 0){
                    BaseNameDto baseNameDto = baseNameDtos.get(0);
                    studentVipPracticeExportDto.setVipOverTeacherId(baseNameDto.getTeacherId());
                    studentVipPracticeExportDto.setVipOverTeacherName(baseNameDto.getTeacherName());
                }
                List<BaseNameDto> baseNameDtos1 = practiceBaseNameMap.get(studentVipPracticeExportDto.getUserId());
                if(baseNameDtos1 != null && baseNameDtos1.size() > 0){
                    BaseNameDto baseNameDto = baseNameDtos1.get(0);
                    studentVipPracticeExportDto.setPracticeOverTeacherId(baseNameDto.getTeacherId());
                    studentVipPracticeExportDto.setPracticeOverTeacherName(baseNameDto.getTeacherName());
                }
            }
        }
        String basePath = new ApplicationHome(this.getClass()).getSource().getParentFile().getPath();
        File file = new File(basePath + "/" + managerDownload.getName());
        FileOutputStream fileOutputStream = new FileOutputStream(file);

        HSSFWorkbook workbook = null;
        try {
            /*String[] header = {"分部", "学员编号", "学生姓名", "课程余额", "声部", "VIP已结束课时数", "VIP未开始课时数", "已结束VIP上课老师编号", "已结束VIP上课老师",
                    "网管课已结束课时数", "网管课未开始课时数", "已结束网管课上课老师编号", "已结束网管课上课老师", "指导老师编号", "指导老师"};
            String[] body = {"organName","userId", "username","courseBalance", "subjectName", "vipOverNum", "vipNotStartNum", "vipOverTeacherId", "vipOverTeacherName"
                    , "practiceOverNum", "practiceNotStartNum", "practiceOverTeacherId", "practiceOverTeacherName","teacherId","teacherName"};*/
            Map<String, String> headMap = getExportMap(new ExportDto(ExportEnum.STUDENT_VIP_PRACTICE, headColumns));
            String[] header = headMap.keySet().toArray(new String[headMap.keySet().size()]);
            String[] body = headMap.values().toArray(new String[headMap.keySet().size()]);
            workbook = POIUtil.exportExcel(header, body, studentVipPracticeExportDtos);
            workbook.write(fileOutputStream);
            fileOutputStream.getFD().sync();
            fileOutputStream.close();

            String folder = "download/" + UploadUtil.getFileFloder();
            String url = storagePluginContext.uploadFile(KS3StoragePlugin.PLUGIN_NAME, folder, file);
            //把记录插入下载表
            managerDownload.setFileUrl(url);
            managerDownload.setStatus(1);
            managerDownloadDao.update(managerDownload);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                fileOutputStream.close();
                workbook.close();
                file.delete();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
