package com.ym.mec.web.controller.education;

import com.ym.mec.biz.dal.entity.CooperationOrgan;
import com.ym.mec.biz.service.CooperationOrganService;
import com.ym.mec.biz.service.OrganizationService;
import com.ym.mec.common.controller.BaseController;
import com.ym.mec.common.entity.HttpResponseResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RequestMapping("eduOrganization")
@Api(tags = "分部服务")
@RestController
public class EduOrganizationController extends BaseController {

    @Autowired
    private OrganizationService organizationService;
    @Autowired
    private CooperationOrganService cooperationOrganService;

    @ApiOperation(value = "获取员工所在分部列表")
    @GetMapping("/queryAllOrgan")
    public Object queryAllOrgan() throws Exception {
        return succeed(organizationService.queryEmployeeOrgan());
    }

    @ApiOperation(value = "获取员工所在分部列表")
    @GetMapping("/queryEmployeeOrgan")
    public Object queryEmployeeOrgan() throws Exception {
        return succeed(organizationService.queryEmployeeOrgan());
    }

    @ApiOperation(value = "根据分部id获取合作单位(学校)列表")
    @GetMapping("/getOrganCooperation")
    public HttpResponseResult<List<CooperationOrgan>> getOrganCooperation(String organId) {
        return succeed(cooperationOrganService.queryByOrganId(organId));
    }
}
